package es.alten.diputacion.add.aspectos;
import java.lang.reflect.Method;
import org.apache.log4j.Logger;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.core.annotation.Order;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import es.alten.diputacion.add.servicios.HistoricoServicio;
@Order(3)
@Aspect
public class AspectoServicioHistorico {
	Logger log = Logger.getLogger(AspectoServicioHistorico.class);
	private HistoricoServicio historicoServicio;  
	
	@Pointcut("within(es.alten.diputacion.add.servicios..*) && @annotation(es.alten.diputacion.add.aspectos.Historico) && args(es.alten.diputacion.add.aspectos.HistoricoRequest)")
	public void puntoDeSalvadoHistorico(){}
	
	@AfterReturning("puntoDeSalvadoHistorico()")
	@Transactional(propagation=Propagation.MANDATORY) 
	public void guardarHistorico(JoinPoint p){
		log.info("#####################  (DESPUES) PASA POR EL ASPECTO GUARDAR HISTORICO");
			Object o = p.getTarget();
			try {
				Method metodo = o.getClass().getMethod(p.getSignature().toShortString(),p.getArgs()[0].getClass());
				Historico historico = metodo.getAnnotation(Historico.class);
				HistoricoRequest request = (HistoricoRequest) p.getArgs()[0];
				String codigoUsuario = request.getCodigoUsuario();
				historicoServicio.guardarHistorico(codigoUsuario,historico.codOperacion());
				
			} catch (SecurityException e) {
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				e.printStackTrace();
			}
	}

//	@Before("puntoDeSalvadoHistorico()")
//	public void antesguardarHistorico(JoinPoint p){
//		log.info("#####################  (ANTES) PASA POR EL ASPECTO GUARDAR HISTORICO");
//	}

	public HistoricoServicio getHistoricoServicio() {
		return historicoServicio;
	}

	public void setHistoricoServicio(HistoricoServicio historico) {
		this.historicoServicio = historico;
	}
}
