package es.alten.diputacion.add.modelo.struts;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;
import org.apache.struts.validator.ValidatorActionForm;
import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.util.UtilidadesCronos;

/**
 * Esta clase sirve para transformar objetos creados en Struts a los modelos
 * definidos para esta aplicacin
 * 
 * @author jluis.martinez
 */
public abstract class BaseForm extends ValidatorActionForm {

	public abstract Object getBean();

	/**
	 * 
	 * @param _fechaNacimiento
	 *            the fechaNacimiento to set
	 */
	protected Date isFecha(String _cadenaFechaAValidar) {
		SimpleDateFormat formato = new SimpleDateFormat("dd/MM/yyyy");
		Date fecha = null;
		// Comprobar el formato dd/mm/yyyy
		if (!((_cadenaFechaAValidar.equals("")) || (_cadenaFechaAValidar == null))) {
			try {
				fecha = formato.parse(_cadenaFechaAValidar);
			} catch (ParseException ex) {
				throw new es.alten.diputacion.add.excepcion.CronosWebException();
			}
		}
		// Eliminar los espacios en blanco de la cadena
		_cadenaFechaAValidar = _cadenaFechaAValidar.trim();
		// Dividir la cadena por tokens
		StringTokenizer cadenaFormato = new StringTokenizer(
				_cadenaFechaAValidar, "/");
		// Array que contendr el da, mes y ao de la cadena trozeada
		int[] campos = new int[3];
		int numeroCampo = 0;
		// Aadir al array de enteros el da, mes y ao
		while (cadenaFormato.hasMoreTokens()) {
			campos[numeroCampo] = Integer.parseInt(cadenaFormato.nextToken());
			numeroCampo++;
		}
		// Validar el array de enteros
		isFechaValida(campos);
		// Devolver fecha validada
		return fecha;
	}

	/**
	 * Validacin del rango de da, mes y ao correspondiente a una fecha
	 * concreta.
	 * 
	 * @param cadenaNumeros
	 *            Array que contiene el dia, mes y ao de una fecha concreta.
	 */
	private void isFechaValida(int[] _cadenaNumeros) {
		Calendar fechaActual = Calendar.getInstance();
		if (((_cadenaNumeros[0] < 1) || (_cadenaNumeros[0] > 31))
				|| ((_cadenaNumeros[1] < 1) || (_cadenaNumeros[1] > 12))
				|| ((_cadenaNumeros[2] < 1950) || (_cadenaNumeros[2] > (fechaActual
						.get(Calendar.YEAR) + 100)))) {
			throw new es.alten.diputacion.add.excepcion.CronosWebException();
		}
	}
	

	protected BigDecimal formatearImporte(String valor_ ){
//		String valor = "11.22.33.44";
		
		String  importeSelcionado = valor_;
		
		
		importeSelcionado = (importeSelcionado == "") ? "0,00"
				: importeSelcionado;
		
//			importeSelcionado = remplazarCaracter(importeSelcionado.toString(),".");
//			importeSelcionado = importeSelcionado.replaceAll(",", ".");
			
		
		String numero[] = new String[]{"","","",""};
		int porcion = 0;
		while(true){
			if(importeSelcionado.contains(".")){
				numero[porcion] = importeSelcionado.substring(importeSelcionado.lastIndexOf('.')+1,importeSelcionado.length());
				importeSelcionado = importeSelcionado.substring(0, importeSelcionado.lastIndexOf('.'));
			}else{
				numero[porcion] = importeSelcionado;
				break;
			}
			porcion++;
		}
		
		String numeroFinal = "";
		for(String parte : numero){
			numeroFinal = parte+numeroFinal;
		}
		numeroFinal = numeroFinal.replaceAll(",", ".");
		
		try{
			return new BigDecimal(numeroFinal);
		}catch (NumberFormatException e) {
			 	UtilidadesCronos.setExcepcionLanzada(new CronosValidacionException(
								"es.alten.cronos.injuve.geex.informe.numero"));
				UtilidadesCronos.getExcepcionLanzada().addError(
						"es.alten.cronos.injuve.geex.informe.numero",
						importeSelcionado);
		}
		
		return new BigDecimal("0.00");
	}

}
