package es.alten.diputacion.add.modelo.struts;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;
import es.alten.diputacion.add.modelo.Expediente;
import es.alten.diputacion.add.modelo.Persona;

@SuppressWarnings("serial")
public class ExpedienteForm extends ActionBaseForm{
	
	private String palabraClave;
	private Date fechaDesde;
	private Date fechaHasta;
	private String fechaDesdeString;
	private String fechaHastaString;
	private String modo;
	private Expediente expediente;

	public ExpedienteForm() {
		super();
		this.expediente = new Expediente();
		this.expediente.setInteresado(new Persona());
	}

	public String getCodExpediente() {
		return expediente.getCodExpediente();
	}
	
	public void setCodExpediente(String codExpediente) {
		this.expediente.setCodExpediente(codExpediente);
	}
	
	public String getCodUorganizativa() {
		return expediente.getCodUorganizativa();
	}
	
	public void setCodUorganizativa(String codUorganizativa) {
		this.expediente.setCodUorganizativa(codUorganizativa);
	}
	
	public String getCodTransitoExp() {
		return expediente.getCodTransitoExp();
	}
	
	public void setCodTransitoExp(String codTransitoExp) {
		this.expediente.setCodTransitoExp(codTransitoExp);
	}
	
	public Date getFechaRegistroExp() {
		return expediente.getFechaRegistroExp();
	}
	
	public void setFechaRegistroExp(String fechaRegistroExp) {
		this.expediente.setFechaRegistroExp(getAsDate(fechaRegistroExp));
	}
	
	public Date getFechaBajaExp() {
		return expediente.getFechaBajaExp();
	}
	
	public void setFechaBajaExp(String fechaBajaExp) {
		this.expediente.setFechaBajaExp(getAsDate(fechaBajaExp));
	}
	
	public String getCodEstado() {
		return expediente.getCodEstado();
	}
	
	public void setCodEstado(String codEstado) {
		this.expediente.setCodEstado(codEstado);
	}
	
	public String getCodSubcategoria() {
		return expediente.getCodSubcategoria();
	}
	
	public void setCodSubcategoria(String codSubcategoria) {
		this.expediente.setCodSubcategoria(codSubcategoria);
	}
	
	public String getCodCategoria() {
		return expediente.getCodCategoria();
	}
	
	public void setCodCategoria(String codCategoria) {
		this.expediente.setCodCategoria(codCategoria);
	}
	
	public String getCodTramite() {
		return expediente.getCodTramite();
	}
	
	public void setCodTramite(String codTramite) {
		this.expediente.setCodTramite(codTramite);
	}
	
	public String getTituloExpediente() {
		return expediente.getTituloExpediente();
	}
	
	public void setTituloExpediente(String tituloExpediente) {
		this.expediente.setTituloExpediente(tituloExpediente);
	}
	
	public String getCodInteresado() {
		return expediente.getCodInteresado();
	}
	
	public void setCodInteresado(String codInteresado) {
		this.expediente.setCodInteresado(codInteresado);
	}
	
	public String getDescripcion() {
		return expediente.getDescripcion();
	}
	
	public void setDescripcion(String descripcion) {
		this.expediente.setDescripcion(descripcion);
	}
	
	public Persona getInteresado() {
		return expediente.getInteresado();
	}
	
	public void setInteresado(Persona interesado) {
		this.expediente.setInteresado(interesado);
	}

	public String getTipoExpediente() {
		return expediente.getTipoExpediente();
	}

	public void setTipoExpediente(String tipoExpediente) {
		this.expediente.setTipoExpediente(tipoExpediente);
	}

	public String getNivelDescripcion() {
		return expediente.getNivelDescripcion();
	}

	public void setNivelDescripcion(String nivelDescripcion) {
		this.expediente.setNivelDescripcion(nivelDescripcion);
	}

	public String getPoliticaEvaluacion() {
		return expediente.getPoliticaEvaluacion();
	}

	public void setPoliticaEvaluacion(String politicaEvaluacion) {
		this.expediente.setPoliticaEvaluacion(politicaEvaluacion);
	}

	public String getObservaciones() {
		return expediente.getObservaciones();
	}

	public void setObservaciones(String observaciones) {
		this.expediente.setObservaciones(observaciones);
	}

	public String getPublicidad() {
		return expediente.getPublicidad();
	}

	public void setPublicidad(String publicidad) {
		this.expediente.setPublicidad(publicidad);
	}

	public String getCodUsuario() {
		return expediente.getCodUsuario();
	}

	public void setCodUsuario(String codUsuario) {
		this.expediente.setCodUsuario(codUsuario);
	}

	public String getNivelProtecDatos() {
		return expediente.getNivelProtecDatos();
	}

	public void setNivelProtecDatos(String nivelProtecDatos) {
		this.expediente.setNivelProtecDatos(nivelProtecDatos);
	}

	public String getEstadoTramitacion() {
		return expediente.getEstadoTramitacion();
	}

	public void setEstadoTramitacion(String estadoTramitacion) {
		this.expediente.setEstadoTramitacion(estadoTramitacion);
	}
	
	public void setCodRepresentante(String codRepresentante) {
		this.expediente.setCodRepresentante(codRepresentante);
	}
	
	public String getCodRepresentante() {
		return expediente.getCodRepresentante();
	}
	
	public String getNombre() {
		return expediente.getInteresado().getNombre();
	}
	
	public void setNombre(String nombre) {
		this.expediente.getInteresado().setNombre(nombre);
	}
	
	public String getDni() {
		return expediente.getInteresado().getNumDocumento();
	}
	
	public void setDni(String dni) {
		this.expediente.getInteresado().setNumDocumento(dni);
	}
	
	public void setModo(String modo) {
		this.modo = modo;
	}

	public String getModo() {
		return modo;
	}
	
	@Override
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		ActionErrors errores = new ActionErrors();		
		return errores;
	}

	@Override
	public ObjetoDominio getBean() {
		return expediente;
	}

	
//	public void setPalabraClave(String palabraClave) {
//		this.palabraClave = palabraClave;
//	}
//
//	public String getPalabraClave() {
//		return palabraClave;
//	}
//	public void setFechaDesde(Date fechaDesde) {
//		this.fechaDesde = fechaDesde;
//	}
//
//	public void setFechaHasta(Date fechaHasta) {
//		this.fechaHasta = fechaHasta;
//	}
//
//	public String getFechaDesde() {
//		if(!(this.fechaDesde.equals(null))){
//			return fechaFormateada(this.fechaDesde);
//		}
//		else {
//			return "";
//		}
//	}
//	
//	public void setFechaDesde(String fechaDesde) {
//		
//		setFechaDesdeString(fechaDesde);
//		if(!"".equals(fechaDesde)){
//			this.fechaDesde= isFecha(fechaDesde);
//		}
//	}
//	
//	public String getFechaHasta() {
//		if(!(this.fechaHasta.equals(null))){
//			return fechaFormateada(this.fechaHasta);
//		}
//		else {
//			return "";
//		}
//	}
//	
//	public void setFechaHasta(String fechaHasta) {
//		
//		setFechaHastaString(fechaHasta);
//		if(!"".equals(fechaHasta)){
//			this.fechaHasta =isFecha(fechaHasta);
//		}
//	}
//	
//	public String getFechaDesdeString() {
//		return fechaDesdeString;
//	}
//
//	public void setFechaDesdeString(String fechaDesdeString) {
//		this.fechaDesdeString = fechaDesdeString;
//	}
//
//	public String getFechaHastaString() {
//		return fechaHastaString;
//	}
//
//	public void setFechaHastaString(String fechaHastaString) {
//		this.fechaHastaString = fechaHastaString;
//	}

	

}
