package es.alten.diputacion.add.servicios;

import java.util.List;

import es.alten.diputacion.add.modelo.Combo;
import es.alten.diputacion.add.modelo.RegistroCombo;

public interface AdministracionCombosServicio {
	/**
	 * Mtodo que devolver todos los combos distintos disponibles
	 * @return Una lista de combos
	 */
public List<Combo>consultarTodosCombos();

/**
 * Mtodo que devolver un combo con todos sus registros
 * @param idCombo, descCombo
 * @return Un objeto de tipo Combo
 */
public Combo consultarTodosRegistrosPorCombo(int idCombo, String descCombo);
/**
 * Mtodo que borra un registro de un combo dado
 * @param idCombo
 * @param idRegistro
 */
public void borrarRegistroCombo(int idCombo, int idRegistro);


/**
 * Mtodo que devolver un RegistroCombo a partir de un combo y un registro dado
 * @param idCombo
 * @param idRegistro
 * @return Un objeto de tipo RegistroCombo
 */
public RegistroCombo consultarRegistroCombo(int idCombo, int idRegistro);


/**
 * Mtodo que actualiza la descripcin de un registro de un combo concreto
 * @param idCombo
 * @param idRegistro
 * @param descRegistro
 * @param valorRegistro
 */
public void actualizarRegistroCombo(int idCombo, int idRegistro, String descRegistro, String valorRegistro);


/**
 * Mtodo que inserta un registro para un combo concreto
 * @param idCombo
 * @param descCombo
 * @param descRegistro
 * @param valorRegistro
 */
public void insertarRegistroCombo(int idCombo, String descCombo,
		String descRegistro, String valorRegistro);

}
