package es.alten.diputacion.add.servicios;

import java.util.List;
import es.alten.diputacion.add.modelo.Documento;
import es.alten.diputacion.add.modelo.Expediente;
import es.alten.diputacion.add.modelo.ExpedienteExpandido;
import es.alten.diputacion.add.modelo.HistoricoTramitacion;
import es.alten.diputacion.add.modelo.SubExpediente;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.ExpedienteExpandidoResultado;
import es.alten.diputacion.add.modelo.resultado.ExpedienteResultado;
import es.alten.diputacion.add.modelo.struts.ExpedienteForm;

public interface ExpedienteServicio {
	
	public List<Tramite> obtenerCombosExpedientes(Usuario usuario);
	
	public ExpedienteResultado validarExpediente(ExpedienteForm expedienteForm);
	
	public ExpedienteExpandidoResultado consultarExpedientes (ExpedienteExpandido expedienteExpandido);
	
	public ExpedienteExpandidoResultado consultarExpedientesOr (ExpedienteExpandido expedienteExpandido);
	
	public ExpedienteExpandidoResultado consultarExpedientesNot (ExpedienteExpandido expedienteExpandido);
	
	public Expediente consultarExpedienteByCodigo (String codExpediente);
	
	public byte[] obtenerCSVExpedientes (String[] elegidos);

	public List<Expediente> consultaExpedientesAsentamiento(Expediente expediente);

	public List<Expediente> consultaTodosExpedientes();

	public ExpedienteExpandido consultarExpedienteCodigo(String codExpediente);

	public List<HistoricoTramitacion> consultarHistoricoTramitacion(String codExpediente);
	
	public List<Documento> consultaTodosDocumentosPorCodigoExpediente(String codExpediente);

	public int modificarExpediente(ExpedienteExpandido expedienteExpandido);

	public int modificarHistorico(HistoricoTramitacion historicoTramitacion);

	public int eliminarExpedientes(String[] elegidos);
	
	public void eliminarDocumento(String codDocumento);

	public String crearExpediente(ExpedienteExpandido expedienteExpandido);

	public String validarExpedienteExpandido(ExpedienteExpandido expedienteExpandido);

	public String crearHistorico(HistoricoTramitacion historicoTramitacion);
	
	public SubExpediente insertarSubExpediente(SubExpediente subExpediente);
	
}
