package es.alten.diputacion.add.servicios;

import java.util.List;
import es.alten.diputacion.add.modelo.Entidad;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.LoginResultado;
	
/**
 * Este servicio nos permitir logar a un usuario en la aplicacin
 * 
 * @author jluis.martinez
 */
public interface LoginServicio {

	
	/**
	 * 	Metodo que devolvera todas las entidades disponibles
	 *  @return Devuelve una lista de entidades.
	 */
	public List<Entidad>consultarTodasEntidades();
	
	/**
	 * 
	 * @param codUsuario identificador nico del usuario
	 * @param codPassword password
	 * @param codEntidad identificador nico 
	 * @return Devuelve una enumeracin con las siguientes constantes:
	 * OK: validacin superada
	 * KAO_USUARIO: El usuario no existe en la entidad especificada
	 * KAO_PASSWORD: la password no es correcta
	 */
	
	//public LoginResultado comprobarPasswordYUsuario(String codUsuario, String codPassword, String codEntidad);
	public LoginResultado comprobarPasswordYUsuario(String codUsuario, String codPassword);
	
}
