package es.alten.diputacion.add.servicios;
import java.util.List;
import es.alten.diputacion.add.modelo.Entidad;
import es.alten.diputacion.add.modelo.resultado.ResultadoUOPorEntidad;
import es.alten.diputacion.add.servicios.request.InActivacionUOrganicas;
import es.alten.diputacion.add.servicios.request.InAltaUO;
public interface UOrganizativaServicio {
	/**
	 * Consulta todas las unidades organizativas existentes
	 * @return lista de las unidades organizativas y sus entidades asociadadas
	 */
	public List<ResultadoUOPorEntidad> consultaTodasUnidadesOrganicas();
	/**
	 * 	Metodo que devolvera todas las entidades disponibles
	 *  @return Devuelve una lista de entidades.
	 */
	public List<Entidad> consultaTodasEntidades();
	
	/**
	 *  Metodo que da de alta una unidad organica
	 * @param unidadOrganica unidad organica que se va a dar de alta
	 */
	public void altaUOrganica(InAltaUO in);
	
	/**
	 * Metodo que activa o desactiva de manera masiva una lista de unidades organizativas
	 * @param listaUnidadesOrganizativas lista de codigos unidades organizativas a activar
	 */
	public void activacionMasivaDeUOrganicas(InActivacionUOrganicas requestActivacion);
	/**
	 * Metodo que  desactiva de manera masiva una lista de de codigos unidades organizativas
	 * @param listaUnidadesOrganizativas lista de unidades organizativas a desactivar
	 */
//	public void desactivacionMasivaDeUOrganicas(String codUsuario,List<String> listaUnidadesOrganizativas);
	
	
	
}
