package es.alten.diputacion.add.servicios.impl;

import java.util.List;

import es.alten.diputacion.add.abstraccion.ComboDao;
import es.alten.diputacion.add.modelo.Combo;
import es.alten.diputacion.add.modelo.RegistroCombo;
import es.alten.diputacion.add.servicios.AdministracionCombosServicio;

public class AdministracionCombosServicioImpl implements AdministracionCombosServicio{
	
	private ComboDao comboDAO;

	@Override
	public List<Combo> consultarTodosCombos() {
		
		return comboDAO.consultarTodosCombos();
	}

	public void setComboDAO(ComboDao comboDAO) {
		this.comboDAO = comboDAO;
	}

	public ComboDao getComboDAO() {
		return comboDAO;
	}

	@Override
	public Combo consultarTodosRegistrosPorCombo(int idCombo, String descCombo) {
		Combo combo = new Combo();
		combo.setIdCombo(idCombo);
		combo.setDescCombo(descCombo);
		combo.setRegistros(comboDAO.consultarTodosRegistrosPorCombo(idCombo));
		return combo;
	}

	@Override
	public void borrarRegistroCombo(int idCombo, int idRegistro) {
	comboDAO.deleteRegistroPorCombo(idCombo,idRegistro);
		
	}

	@Override
	public RegistroCombo consultarRegistroCombo(int idCombo, int idRegistro) {
		
		return comboDAO.consultarRegistroCombo(idCombo, idRegistro);
	}

	@Override
	public void actualizarRegistroCombo(int idCombo, int idRegistro, String descRegistro, String valorRegistro) {
		comboDAO.updateRegistroPorCombo(idCombo, idRegistro, descRegistro, valorRegistro);
		
	}

	@Override
	public void insertarRegistroCombo(int idCombo, String descCombo,
			String descRegistro, String valorRegistro) {
		comboDAO.insertRegistroPorCombo(idCombo, descCombo, descRegistro, valorRegistro);
		
	}

}
