package es.alten.diputacion.add.servicios.impl;

import java.util.ArrayList;
import java.util.Collections;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import es.alten.diputacion.add.abstraccion.SubtipologiaDao;
import es.alten.diputacion.add.abstraccion.TipologiaDao;
import es.alten.diputacion.add.abstraccion.TramiteDao;
import es.alten.diputacion.add.modelo.Subtipologia;
import es.alten.diputacion.add.modelo.Tipologia;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.resultado.TramiteConTipologiaGestionableResultado;

import es.alten.diputacion.add.servicios.AdministracionTramiteServicio;
@Transactional()
public class AdministracionTramitesServicioImpl implements AdministracionTramiteServicio {

	private TramiteDao tramiteDAO;
	private SubtipologiaDao subtipologiaDAO;
	private TipologiaDao tipologiaDAO;
	
	

	public TramiteDao getTramiteDAO() {
		return tramiteDAO;
	}
	public void setTramiteDAO(TramiteDao tramiteDAO) {
		this.tramiteDAO = tramiteDAO;
	}
	public SubtipologiaDao getSubtipologiaDAO() {
		return subtipologiaDAO;
	}
	public void setSubtipologiaDAO(SubtipologiaDao subtipologiaDAO) {
		this.subtipologiaDAO = subtipologiaDAO;
	}
	public TipologiaDao getTipologiaDAO() {
		return tipologiaDAO;
	}
	public void setTipologiaDAO(TipologiaDao tipologiaDAO) {
		this.tipologiaDAO = tipologiaDAO;
	}
	@Override
	public List<TramiteConTipologiaGestionableResultado> obtenerTramitesConTipologiaGestionable() {
		
		List <TramiteConTipologiaGestionableResultado>listaResultadoTramitesGestionables = new ArrayList<TramiteConTipologiaGestionableResultado>();
		List <Tramite> tramites = tramiteDAO.consultarTramitesTipologiaGestionable();
		
		for (Tramite tramite : tramites){
			TramiteConTipologiaGestionableResultado tramiteGestionableResultado = new TramiteConTipologiaGestionableResultado();
			Subtipologia subtipologia = subtipologiaDAO.consultaSubtipologiaPorTramite(tramite.getCodSubtipologia());
			tramiteGestionableResultado.setSubtipologia(subtipologia);
			Tipologia tipologia = tipologiaDAO.consultaTipologiaPorSubtipologia(subtipologia.getCodTipologia());
			tramiteGestionableResultado.setTipologia(tipologia);
			tramiteGestionableResultado.setTramite(tramite);
			listaResultadoTramitesGestionables.add(tramiteGestionableResultado);
		}	
		Collections.sort(listaResultadoTramitesGestionables);
		return listaResultadoTramitesGestionables;
	}
	@Override
	public Tipologia obtenerTipologiaGestionable() {
		Tipologia tipologiagestionable = tipologiaDAO.selectTipologiaGestionable();
		return tipologiagestionable;
	}
	@Override
	public List<Subtipologia> obtenerSubtipologiasporTipologiaGestionable() {
		List<Subtipologia> subtipologiasgestionables = subtipologiaDAO.selectSubtipologiaPorTipologiaGestionable(tipologiaDAO.selectTipologiaGestionable().getCodTipologia());
		return subtipologiasgestionables;
	}
	@Override
	public TramiteConTipologiaGestionableResultado altaTramite(Tramite tramite) {
//		tramite.validar();
		Tramite tramiteResultadoDAO = new Tramite();
		tramiteResultadoDAO = tramiteDAO.insertTramite(tramite);
		
		TramiteConTipologiaGestionableResultado tramiteResultado = new TramiteConTipologiaGestionableResultado();
		tramiteResultado.setTramite(tramiteResultadoDAO);
		Subtipologia subtipologia = subtipologiaDAO.consultaSubtipologiaPorTramite(tramiteResultadoDAO.getCodSubtipologia());
		tramiteResultado.setSubtipologia(subtipologia);
		Tipologia tipologia = tipologiaDAO.consultaTipologiaPorSubtipologia(subtipologia.getCodTipologia());
		tramiteResultado.setTipologia(tipologia);
		
		return tramiteResultado;
		
	}
	@Override
	public TramiteConTipologiaGestionableResultado modificacionTramite(
			Tramite tramite) {
		Tramite tramiteResultadoDAO = new Tramite();
		tramiteResultadoDAO = tramiteDAO.updateTramite(tramite);
		
		TramiteConTipologiaGestionableResultado tramiteResultado = new TramiteConTipologiaGestionableResultado();
		tramiteResultado.setTramite(tramiteResultadoDAO);
		Subtipologia subtipologia = subtipologiaDAO.consultaSubtipologiaPorTramite(tramiteResultadoDAO.getCodSubtipologia());
		tramiteResultado.setSubtipologia(subtipologia);
		Tipologia tipologia = tipologiaDAO.consultaTipologiaPorSubtipologia(subtipologia.getCodTipologia());
		tramiteResultado.setTipologia(tipologia);
		
		return tramiteResultado;
	}
	@Override
	public Tramite buscarTramitePorCodigoTramite(String id_tramite) {
		return tramiteDAO.buscarTramitePorIdTramite(id_tramite);
	}
	@Override
	public void borrarTramitePorCodigoTramite(String idTramite) {
		tramiteDAO.deleteTramite(idTramite);
		
	}

//	public TramiteConTipologiaGestionableResultado validarTramite(
//			Tramite tramite) {
//		Logger log = Logger.getLogger(AdministracionTramitesServicioImpl.class);
//		TramiteConTipologiaGestionableResultado resultado = new TramiteConTipologiaGestionableResultado();
//		if(tramite.getCodSubtipologia()==null){
//			resultado.setConfirmacion(ConfirmacionTramite.SUBTIPOLOGIANULL);
//			resultado.setTramite(null);
//		}
//		else if(tramite.getDescTramite()==null){
//			resultado.setConfirmacion(ConfirmacionTramite.DESCNULL);
//			resultado.setTramite(null);
//		}
//		else{
//			resultado.setConfirmacion(ConfirmacionTramite.CORRECTO);
//			resultado.setTramite(tramite);
//		}
//		return resultado;
//	}
}
