package es.alten.diputacion.add.servicios.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import es.alten.diputacion.add.abstraccion.UsuarioDAO;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.UsuarioResultado;
import es.alten.diputacion.add.servicios.AdministracionUsuarioServicio;
@Transactional()
public class AdministracionUsuariosServicioImpl implements AdministracionUsuarioServicio {

	private UsuarioDAO usuarioDAO;
	
	public void setUsuarioDAO(UsuarioDAO usuarioDAO) {
		this.usuarioDAO = usuarioDAO;
	}

	public UsuarioDAO getUsuarioDAO() {
		return usuarioDAO;
	}

	@Override
	public List<UsuarioResultado> consultarTodosUsuarios() {
		List <UsuarioResultado>listaUsuariosResultado = new ArrayList<UsuarioResultado>();
		List <Usuario>usuarios = usuarioDAO.consultarTodosUsuarios();
		for (Usuario usuario : usuarios){
			UsuarioResultado usuarioResultado = new UsuarioResultado();
			usuarioResultado.setUsuario(usuario);
			listaUsuariosResultado.add(usuarioResultado);
		
		}
		Collections.sort(listaUsuariosResultado);
		return listaUsuariosResultado;
	}

	@Override
	public UsuarioResultado altaUsuario(Usuario usuario) {
		Usuario usuarioResultadoDAO = new Usuario();
		usuarioResultadoDAO = usuarioDAO.insertUsuario(usuario);
		UsuarioResultado usuarioResultado = new UsuarioResultado();
		usuarioResultado.setUsuario(usuarioResultadoDAO);
		return usuarioResultado;
	}

	@Override
	public UsuarioResultado modificacionUsuario(Usuario usuario) {
		Usuario usuarioResultadoDAO = new Usuario();
		usuarioResultadoDAO = usuarioDAO.updateUsuario(usuario);
		UsuarioResultado usuarioResultado = new UsuarioResultado();
		usuarioResultado.setUsuario(usuarioResultadoDAO);
		return usuarioResultado;
	}

	@Override
	public Usuario buscarUsuarioPorCodigoUsuario(String idUsuario) {
		return usuarioDAO.consultarUsuarioPorUsuarioYEntidad(idUsuario);
	}

	@Override
	public void borrarUsuarioPorCodigoUsuario(String idUsuario) {
		usuarioDAO.deleteUsuario(idUsuario);
		
	}

	
}
