package es.alten.diputacion.add.servicios.impl;

import es.alten.diputacion.add.abstraccion.UsuarioDAO;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.transaction.annotation.Transactional;



import es.alten.diputacion.add.abstraccion.TramiteDao;
import es.alten.diputacion.add.abstraccion.UsuarioTramiteDao;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.UsuarioTramite;
import es.alten.diputacion.add.servicios.AsignarUsuariosTramiteServicio;

@Transactional (rollbackFor = DataAccessException.class)
public class AsignarUsuariosTramiteServicioImpl implements AsignarUsuariosTramiteServicio {
	private Logger logger = Logger.getLogger(AsignarUsuariosTramiteServicioImpl.class);
	public Logger getLogger() {
		return logger;
	}
	public void setLogger(Logger logger) {
		this.logger = logger;
	}
	private UsuarioDAO daoUsuario;
	private  TramiteDao daoTramite;
	private UsuarioTramiteDao usuarioTramiteDao;
	
	public UsuarioTramiteDao getUsuarioTramiteDao() {
		return usuarioTramiteDao;
	}
	public void setUsuarioTramiteDao(UsuarioTramiteDao usuarioTramiteDao) {
		this.usuarioTramiteDao = usuarioTramiteDao;
	}
	public UsuarioDAO getDaoUsuario() {
		return daoUsuario;
	}
	public void setDaoUsuario(UsuarioDAO daoUsuario) {
		this.daoUsuario = daoUsuario;
	}
	public TramiteDao getDaoTramite() {
		return daoTramite;
	}
	public void setDaoTramite(TramiteDao daoTramite) {
		this.daoTramite = daoTramite;
	}
/*	public List<Tramite> consultaTodasEntidades() {
		return null;//daoTramite.consultarTodasTramites();
	}*/
	public List<Tramite> consultarTodosTramites(){
		return daoTramite.consultarTodasTramites();
	}
	public List<Usuario> consultaTodosUsuarios(){
		  return daoUsuario.consultarTodosUsuarios();
		}
	@Override
	public List<Usuario> listaUsuariosValidos(String codTramite) {
		// TODO Auto-generated method stub
		return usuarioTramiteDao.selectCodUsuarioValido(codTramite);
	}
	@Override
	public List<Usuario> listaUsuarioNoValidos(String codTramite) {
		// TODO Auto-generated method stub
		return usuarioTramiteDao.selectCodUsuarioNoValido(codTramite);
	}
	@Override
	public void insertarUsuarioTramite(UsuarioTramite usrTramite) {
		// TODO Auto-generated method stub
		usuarioTramiteDao.insertCodUsuarioCodTramite(usrTramite);
	}
	@Override
	public void deleteUsuarioTramite(UsuarioTramite usrTramite) {
		// TODO Auto-generated method stub
		usuarioTramiteDao.deleteCodUsuarioCodTramite(usrTramite);
		
	}
	
}

