package es.alten.diputacion.add.servicios.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.DocumentoDao;
import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.Documento;
import es.alten.diputacion.add.modelo.resultado.DocumentoResultado;
import es.alten.diputacion.add.modelo.resultado.DocumentoResultado.ConfirmacionDocumento;
import es.alten.diputacion.add.modelo.struts.DocumentoForm;
import es.alten.diputacion.add.servicios.DocumentoServicio;
import es.alten.diputacion.add.util.CSVAddUtils;
import es.alten.diputacion.add.util.TipoCondicion;

public class DocumentoServicioImpl implements DocumentoServicio{
	
	private DocumentoDao documentoDAO;
	
	public DocumentoDao getDocumentoDAO() {
		return documentoDAO;
	}

	public void setDocumentoDAO(DocumentoDao documentoDAO) {
		this.documentoDAO = documentoDAO;
	}

	public DocumentoResultado consultarDocumentos (DocumentoResultado resultado){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condiciones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigoExpediente = new HashMap<String, TipoCondicion>();
		condicionCodigoExpediente.put("ADD_DOCUMENTO.STR_CODEXPEDIENTE", TipoCondicion.Igual);
		listaMetodos.put("getCodExpediente", condicionCodigoExpediente);
		
		// Aadimos las condiciones para el codigo del documento
		Map<String, TipoCondicion> condicionCodigoDocumento = new HashMap<String, TipoCondicion>();
		condicionCodigoDocumento.put("ADD_DOCUMENTO.STR_CODDOCUMENTO", TipoCondicion.Igual);
		listaMetodos.put("getCodDocumento", condicionCodigoDocumento);
		
		// Aadimos las condicones para la fecha alta de inicio
		Map<String, TipoCondicion> condicionFechaAltaInicio = new HashMap<String, TipoCondicion>();
		condicionFechaAltaInicio.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaAltaIni", condicionFechaAltaInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaAltaFinal = new HashMap<String, TipoCondicion>();
		condicionFechaAltaFinal.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaAltaFinal", condicionFechaAltaFinal);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDocInicio = new HashMap<String, TipoCondicion>();
		condicionFechaDocInicio.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaDocIni", condicionFechaDocInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaDocFinal = new HashMap<String, TipoCondicion>();
		condicionFechaDocFinal.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaDocFinal", condicionFechaDocFinal);
		
		List<Documento> listaDocumentos = documentoDAO.consultaDocumentosPorCriterios(resultado.getDocumento(), listaMetodos);
		
		resultado.setListaDocumentos(listaDocumentos);
		resultado.setContador(listaDocumentos.size());
		
		return resultado;
	}
	
	public DocumentoResultado consultarDocumentosOr (DocumentoResultado resultado){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condiciones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigoExpediente = new HashMap<String, TipoCondicion>();
		condicionCodigoExpediente.put("ADD_DOCUMENTO.STR_CODEXPEDIENTE", TipoCondicion.Igual);
		listaMetodos.put("getCodExpediente", condicionCodigoExpediente);
		
		// Aadimos las condiciones para el codigo del documento
		Map<String, TipoCondicion> condicionCodigoDocumento = new HashMap<String, TipoCondicion>();
		condicionCodigoDocumento.put("ADD_DOCUMENTO.STR_CODDOCUMENTO", TipoCondicion.Igual);
		listaMetodos.put("getCodDocumento", condicionCodigoDocumento);
		
		// Aadimos las condicones para la fecha alta de inicio
		Map<String, TipoCondicion> condicionFechaAltaInicio = new HashMap<String, TipoCondicion>();
		condicionFechaAltaInicio.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaAltaIni", condicionFechaAltaInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaAltaFinal = new HashMap<String, TipoCondicion>();
		condicionFechaAltaFinal.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaAltaFinal", condicionFechaAltaFinal);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDocInicio = new HashMap<String, TipoCondicion>();
		condicionFechaDocInicio.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaDocIni", condicionFechaDocInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaDocFinal = new HashMap<String, TipoCondicion>();
		condicionFechaDocFinal.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaDocFinal", condicionFechaDocFinal);
		
		List<Documento> listaDocumentos = documentoDAO.consultaDocumentosPorCriteriosOr(resultado.getDocumento(), listaMetodos);
		
		resultado.setListaDocumentos(listaDocumentos);
		resultado.setContador(listaDocumentos.size());
		
		return resultado;
	}

	public DocumentoResultado consultarDocumentosNot (DocumentoResultado resultado){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condiciones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigoExpediente = new HashMap<String, TipoCondicion>();
		condicionCodigoExpediente.put("ADD_DOCUMENTO.STR_CODEXPEDIENTE", TipoCondicion.Distinto);
		listaMetodos.put("getCodExpediente", condicionCodigoExpediente);
		
		// Aadimos las condiciones para el codigo del documento
		Map<String, TipoCondicion> condicionCodigoDocumento = new HashMap<String, TipoCondicion>();
		condicionCodigoDocumento.put("ADD_DOCUMENTO.STR_CODDOCUMENTO", TipoCondicion.Distinto);
		listaMetodos.put("getCodDocumento", condicionCodigoDocumento);
		
		// Aadimos las condicones para la fecha alta de inicio
		Map<String, TipoCondicion> condicionFechaAltaInicio = new HashMap<String, TipoCondicion>();
		condicionFechaAltaInicio.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaAltaIni", condicionFechaAltaInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaAltaFinal = new HashMap<String, TipoCondicion>();
		condicionFechaAltaFinal.put("ADD_DOCUMENTO.FEC_FECHACADUCIDAD", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaAltaFinal", condicionFechaAltaFinal);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDocInicio = new HashMap<String, TipoCondicion>();
		condicionFechaDocInicio.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaDocIni", condicionFechaDocInicio);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaDocFinal = new HashMap<String, TipoCondicion>();
		condicionFechaDocFinal.put("ADD_DOCUMENTO.FEC_FECHADOCUMENTO", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaDocFinal", condicionFechaDocFinal);
		
		List<Documento> listaDocumentos = documentoDAO.consultaDocumentosPorCriterios(resultado.getDocumento(), listaMetodos);
		
		resultado.setListaDocumentos(listaDocumentos);
		resultado.setContador(listaDocumentos.size());
		
		return resultado;
	}
	
	@Override
	public byte[] obtenerCSVDocumentos(String[] elegidos) {

		byte[] archivoCSV = null;

		if (elegidos == null || elegidos.length == 0) {
			throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar.vacio");
		}
		
		List<Documento> documentos = new ArrayList <Documento>();


		for(String elegido : elegidos){
			Documento documento = documentoDAO.consultaDocumentoPorCodigo(elegido);
			documentos.add(documento);
		}
		
		archivoCSV = CSVAddUtils.obtenerCSVDocumento(documentos);

		return archivoCSV;
	}
	
	@Override
	public DocumentoResultado validarDocumento(DocumentoForm documentoForm) {
		@SuppressWarnings("unused")
		Logger log = Logger.getLogger(DocumentoServicioImpl.class);
		DocumentoResultado resultado = new DocumentoResultado(); 
		
		//TODO FALTA VALIDAR

		resultado.setConfirmacion(ConfirmacionDocumento.CORRECTO);
		resultado.setDocumento(documentoForm);

		return resultado;
	}

	@Override
	public int eliminarDocumento(String codDocumento) {
		documentoDAO.deleteDocumento(codDocumento);
		return 0;
	}

	@Override
	public String crearDocumento(Documento documento) {
		int respuesta = documentoDAO.insertDocumento(documento);
		if (respuesta == 0) {
			return "INCORRECTO";
		}
		else {
			String codDocumento = Integer.toString(respuesta);
			return codDocumento;
		}
	}

}
