package es.alten.diputacion.add.servicios.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.DocumentoDao;
import es.alten.diputacion.add.abstraccion.ExpedienteDao;

import es.alten.diputacion.add.abstraccion.HistoricoTramitacionDao;

import es.alten.diputacion.add.abstraccion.ObjetoDigitalDao;

import es.alten.diputacion.add.abstraccion.PersonaDao;
import es.alten.diputacion.add.abstraccion.SubExpedienteDao;
import es.alten.diputacion.add.abstraccion.SubtipologiaDao;
import es.alten.diputacion.add.abstraccion.TipologiaDao;
import es.alten.diputacion.add.abstraccion.TramiteDao;
import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.Documento;
import es.alten.diputacion.add.modelo.Expediente;

import es.alten.diputacion.add.modelo.ExpedienteExpandido;
import es.alten.diputacion.add.modelo.HistoricoTramitacion;

import es.alten.diputacion.add.modelo.ObjetoDigital;

import es.alten.diputacion.add.modelo.SubExpediente;
import es.alten.diputacion.add.modelo.Subtipologia;
import es.alten.diputacion.add.modelo.Tipologia;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.ExpedienteExpandidoResultado;
import es.alten.diputacion.add.modelo.resultado.ExpedienteResultado;
import es.alten.diputacion.add.modelo.resultado.ExpedienteResultado.Confirmacion;
import es.alten.diputacion.add.modelo.struts.ExpedienteForm;
import es.alten.diputacion.add.servicios.ExpedienteServicio;
import es.alten.diputacion.add.util.CSVAddUtils;
import es.alten.diputacion.add.util.TipoCondicion;

public class ExpedienteServicioImpl implements ExpedienteServicio{
	
	private ExpedienteDao expedienteDAO;
	private TramiteDao tramiteDAO;
	private SubtipologiaDao subtipologiaDAO;
	private TipologiaDao tipologiaDAO;
	private PersonaDao personaDAO;
	private SubExpedienteDao subExpedienteDAO;
	private HistoricoTramitacionDao historicoTramitacionDAO;
	private DocumentoDao documentoDAO;
	private ObjetoDigitalDao objetoDigitalDAO;
	
	public ObjetoDigitalDao getObjetoDigitalDAO() {
		return objetoDigitalDAO;
	}

	public void setObjetoDigitalDAO(ObjetoDigitalDao objetoDigitalDAO) {
		this.objetoDigitalDAO = objetoDigitalDAO;
	}

	public void setExpedienteDAO(ExpedienteDao expedienteDAO) {
		this.expedienteDAO = expedienteDAO;
	}

	public ExpedienteDao getExpedienteDAO() {
		return expedienteDAO;
	}

	public void setTramiteDAO(TramiteDao tramiteDAO) {
		this.tramiteDAO = tramiteDAO;
	}

	public TramiteDao getTramiteDAO() {
		return tramiteDAO;
	}
	
	public SubtipologiaDao getSubtipologiaDAO() {
		return subtipologiaDAO;
	}

	public void setSubtipologiaDAO(SubtipologiaDao subtipologiaDAO) {
		this.subtipologiaDAO = subtipologiaDAO;
	}		

	public void setTipologiaDAO(TipologiaDao tipologiaDAO) {
		this.tipologiaDAO = tipologiaDAO;
	}

	public TipologiaDao getTipologiaDAO() {
		return tipologiaDAO;
	}

	public PersonaDao getPersonaDAO() {
		return personaDAO;
	}

	public void setPersonaDAO(PersonaDao personaDAO) {
		this.personaDAO = personaDAO;
	}
	
	public HistoricoTramitacionDao getHistoricoTramitacionDAO() {
		return historicoTramitacionDAO;
	}

	public void setHistoricoTramitacionDAO(HistoricoTramitacionDao historicoTramitacionDAO) {
		this.historicoTramitacionDAO = historicoTramitacionDAO;
	}

	public List<Tramite> obtenerCombosExpedientes(Usuario usuario){
		
		List<Tramite> tramites = tramiteDAO.consultarTramitesUsuario(usuario.getCodigo());
		
		for (Tramite tramite : tramites){
			
			Subtipologia subtipologia = subtipologiaDAO.consultaSubtipologiaPorTramite(tramite.getCodSubtipologia());
			tramite.setSubtipologia(subtipologia);
			Tipologia tipologia = tipologiaDAO.consultaTipologiaPorSubtipologia(subtipologia.getCodTipologia());
			tramite.setTipologia(tipologia);	
		}
	
		return tramites;
	}
	
	public ExpedienteExpandidoResultado consultarExpedientes (ExpedienteExpandido expedienteExpandido){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condicones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigo = new HashMap<String, TipoCondicion>();
		condicionCodigo.put("EXPE.STR_CODEXPEDIENTE", TipoCondicion.Igual);
		listaMetodos.put("getCodExpediente", condicionCodigo);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDesde = new HashMap<String, TipoCondicion>();
		condicionFechaDesde.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaDesde", condicionFechaDesde);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaHasta = new HashMap<String, TipoCondicion>();
		condicionFechaHasta.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaHasta", condicionFechaHasta);		
		
		// Aadimos las condicones para la visibilidad
		Map<String, TipoCondicion> condicionVisible = new HashMap<String, TipoCondicion>();
		condicionVisible.put("EXPE.IND_VISIBLE", TipoCondicion.Igual);
		listaMetodos.put("getVisible", condicionVisible);
		expedienteExpandido.setVisible("S");
		
		List<ExpedienteExpandido> listaExpedientes = expedienteDAO.consultaExpedientesPorCriterios(expedienteExpandido, listaMetodos);
		
		ExpedienteExpandidoResultado expedienteExpandidoResultado = new ExpedienteExpandidoResultado();
		expedienteExpandidoResultado.setListaExpedientes(listaExpedientes);
		expedienteExpandidoResultado.setContador(listaExpedientes.size());
		
		return expedienteExpandidoResultado;
	}
	
	public ExpedienteExpandidoResultado consultarExpedientesOr (ExpedienteExpandido expedienteExpandido){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condicones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigo = new HashMap<String, TipoCondicion>();
		condicionCodigo.put("EXPE.STR_CODEXPEDIENTE", TipoCondicion.Igual);
		listaMetodos.put("getCodExpediente", condicionCodigo);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDesde = new HashMap<String, TipoCondicion>();
		condicionFechaDesde.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaDesde", condicionFechaDesde);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaHasta = new HashMap<String, TipoCondicion>();
		condicionFechaHasta.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaHasta", condicionFechaHasta);
		
		// Aadimos las condicones para la visibilidad
		Map<String, TipoCondicion> condicionVisible = new HashMap<String, TipoCondicion>();
		condicionVisible.put("EXPE.IND_VISIBLE", TipoCondicion.Igual);
		listaMetodos.put("getVisible", condicionVisible);
		expedienteExpandido.setVisible("S");
		
		List<ExpedienteExpandido> listaExpedientes = expedienteDAO.consultaExpedientesPorCriteriosOr(expedienteExpandido, listaMetodos);
		
		ExpedienteExpandidoResultado expedienteExpandidoResultado = new ExpedienteExpandidoResultado();
		expedienteExpandidoResultado.setListaExpedientes(listaExpedientes);
		expedienteExpandidoResultado.setContador(listaExpedientes.size());
		
		return expedienteExpandidoResultado;
	}
	
	public ExpedienteExpandidoResultado consultarExpedientesNot (ExpedienteExpandido expedienteExpandido){
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condicones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigo = new HashMap<String, TipoCondicion>();
		condicionCodigo.put("EXPE.STR_CODEXPEDIENTE", TipoCondicion.Distinto);
		listaMetodos.put("getCodExpediente", condicionCodigo);
		
		// Aadimos las condicones para la fecha desde
		Map<String, TipoCondicion> condicionFechaDesde = new HashMap<String, TipoCondicion>();
		condicionFechaDesde.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MenorIgual);
		listaMetodos.put("getFechaDesde", condicionFechaDesde);
		
		// Aadimos las condicones para la fecha hasta
		Map<String, TipoCondicion> condicionFechaHasta = new HashMap<String, TipoCondicion>();
		condicionFechaHasta.put("EXPE.FEC_FECHAINICIOEXPEDIENTE", TipoCondicion.MayorIgual);
		listaMetodos.put("getFechaHasta", condicionFechaHasta);
		
		// Aadimos las condicones para la visibilidad
		Map<String, TipoCondicion> condicionVisible = new HashMap<String, TipoCondicion>();
		condicionVisible.put("EXPE.IND_VISIBLE", TipoCondicion.Igual);
		listaMetodos.put("getVisible", condicionVisible);
		expedienteExpandido.setVisible("S");
		
		List<ExpedienteExpandido> listaExpedientes = expedienteDAO.consultaExpedientesPorCriterios(expedienteExpandido, listaMetodos);
		
		ExpedienteExpandidoResultado expedienteExpandidoResultado = new ExpedienteExpandidoResultado();
		expedienteExpandidoResultado.setListaExpedientes(listaExpedientes);
		expedienteExpandidoResultado.setContador(listaExpedientes.size());
		
		return expedienteExpandidoResultado;
	}
	
	@Override
	public byte[] obtenerCSVExpedientes(String[] elegidos) {

		byte[] archivoCSV = null;

		if (elegidos == null || elegidos.length == 0) {
			throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar.vacio");
		}
		
		List<Expediente> expedientes = new ArrayList <Expediente>();

		for(String elegido : elegidos){
			Expediente expediente = expedienteDAO.consultaExpedientePorCodigo(elegido);
			expedientes.add(expediente);
		}
		
		archivoCSV = CSVAddUtils.obtenerCSVExpediente(expedientes);

		return archivoCSV;
	}
	
	@Override
	public ExpedienteResultado validarExpediente(ExpedienteForm expedienteForm) {
		@SuppressWarnings("unused")
		Logger log = Logger.getLogger(ExpedienteServicioImpl.class);
		ExpedienteResultado resultado = new ExpedienteResultado(); 
		
		//TODO FALTA VALIDAR

		resultado.setConfirmacion(Confirmacion.CORRECTO);
		resultado.setExpediente(expedienteForm);

		return resultado;
	}

	public SubExpedienteDao getSubExpedienteDAO() {
		return subExpedienteDAO;
	}

	public void setSubExpedienteDAO(SubExpedienteDao subExpedienteDAO) {
		this.subExpedienteDAO = subExpedienteDAO;
	}

	@Override
	public Expediente consultarExpedienteByCodigo(String codExpediente) {
		Expediente expediente = expedienteDAO.consultaExpedientePorCodigo(codExpediente);
		return expediente;
	}

	@Override
	public List<Expediente> consultaExpedientesAsentamiento(Expediente expediente) {
		
		// Lista con los criterios que se usaran en la busqueda
		Map<String, Map<String, TipoCondicion>> listaMetodos = new HashMap<String, Map<String, TipoCondicion>>();
				
		// Aadimos las condicones para el codigo del expediente
		Map<String, TipoCondicion> condicionCodigo = new HashMap<String, TipoCondicion>();
		condicionCodigo.put("EX.STR_CODEXPEDIENTE", TipoCondicion.Igual);
		listaMetodos.put("getCodExpediente", condicionCodigo);
		
		// Aadimos las condicones para el titulo del expediente
		Map<String, TipoCondicion> condicionTitulo = new HashMap<String, TipoCondicion>();
		condicionTitulo.put("EX.STR_DESCRIPCION", TipoCondicion.Igual);
		listaMetodos.put("getDescripcion", condicionTitulo);
		
		// Aadimos las condicones para el nombre de la persona
		Map<String, TipoCondicion> condicionNombre = new HashMap<String, TipoCondicion>();
		condicionNombre.put("PE.STR_NOMBREPERSONA", TipoCondicion.Igual);
		listaMetodos.put("getNombrePersona", condicionNombre);
		
		// Aadimos las condicones para el dni de la persona
		Map<String, TipoCondicion> condicionDni = new HashMap<String, TipoCondicion>();
		condicionDni.put("PE.STR_NUMDOCUMENTOPERSONA", TipoCondicion.Igual);
		listaMetodos.put("getDniPersona", condicionDni);
		
		// Aadimos las condicones para el codigo del estado
		Map<String, TipoCondicion> condicionEstado = new HashMap<String, TipoCondicion>();
		condicionEstado.put("EX.IND_CODESTADO", TipoCondicion.Igual);
		listaMetodos.put("getCodEstado", condicionEstado);
		
		// Aadimos las condicones para la visibilidad
		Map<String, TipoCondicion> condicionVisible = new HashMap<String, TipoCondicion>();
		condicionVisible.put("EX.IND_VISIBLE", TipoCondicion.Igual);
		listaMetodos.put("getVisible", condicionVisible);
		expediente.setVisible("S");
		
		if (!(expediente.getCodTramite().equals("-3"))){// Aadimos las condicones para el codigo del estado
			Map<String, TipoCondicion> condicionTramite = new HashMap<String, TipoCondicion>();
			condicionTramite.put("EX.STR_CODTRAMITE", TipoCondicion.Igual);
			listaMetodos.put("getCodTramite", condicionTramite);
		}
		
		List<Expediente> listaExpedientes = expedienteDAO.consultaExpedientesPorCriteriosAsentamiento(expediente, listaMetodos);
		
		return listaExpedientes;
	}

	@Override
	public List<Expediente> consultaTodosExpedientes() {
		
		List<Expediente> listaExpedientes = expedienteDAO.consultarTodosExpedientes();
		
		return listaExpedientes;
	}

	@Override
	public ExpedienteExpandido consultarExpedienteCodigo(String codExpediente) {
		ExpedienteExpandido expedienteExpandido = expedienteDAO.consultaExpedienteCodigo(codExpediente);
		return expedienteExpandido;
	}

	@Override
	public List<HistoricoTramitacion> consultarHistoricoTramitacion(String codExpediente) {
		List<HistoricoTramitacion> listaHistoricoTramitacion = historicoTramitacionDAO.consultarHistoricoTramitacion(codExpediente);
		return listaHistoricoTramitacion;
	}

	@Override
	public List<Documento> consultaTodosDocumentosPorCodigoExpediente(
			String codExpediente) {
		List<Documento> listaDocumentos = documentoDAO.consultaDocumentosPorCodigoExpediente(codExpediente);
		for(Documento documento : listaDocumentos){
			List<ObjetoDigital>listaObjetosDigitalesPorDocumento = objetoDigitalDAO.consultarObjetosDigitalesPorCodigoDocumento(documento.getCodDocumento());
			documento.setObjetosDigitales(listaObjetosDigitalesPorDocumento);
		}
		return listaDocumentos;
	}

	public void setDocumentoDAO(DocumentoDao documentoDAO) {
		this.documentoDAO = documentoDAO;
	}

	public DocumentoDao getDocumentoDAO() {
		return documentoDAO;
	}

	@Override
	public int modificarExpediente(ExpedienteExpandido expedienteExpandido) {
		int respuesta = expedienteDAO.updateExpedienteExpandido(expedienteExpandido);
		return respuesta;
	}

	@Override
	public int modificarHistorico(HistoricoTramitacion historicoTramitacion) {
		int respuesta = historicoTramitacionDAO.updateTramitacion(historicoTramitacion);
		return respuesta;
	}

	@Override
	public int eliminarExpedientes(String[] elegidos) {
		
		int contador=0;
		for(String elegido : elegidos){
			int respuesta = expedienteDAO.eliminarExpediente(elegido);
			contador = contador + respuesta;
		}
		return 0;
	}

	@Override
	public void eliminarDocumento(String codDocumento) {
		documentoDAO.deleteDocumento(codDocumento);
		
	}

	@Override
	public String crearExpediente(ExpedienteExpandido expedienteExpandido) {
		expedienteExpandido.setCodTransitoExp("1");
		expedienteExpandido.setVisible("S");
		//expedienteExpandido.setCodExpediente("EX033");
		expedienteExpandido.setNivelDescripcion("1");
		expedienteExpandido.setPoliticaEvaluacion("1");
		expedienteExpandido.setCodUsuario("1");
		
		int respuesta = expedienteDAO.createExpediente(expedienteExpandido);
		if (respuesta == 0) {
			return "INCORRECTO";
		}
		else {
			String codExpediente = Integer.toString(respuesta);
			return codExpediente;
			//return expedienteExpandido.getCodExpediente();
		}
	}

	@Override
	public String validarExpedienteExpandido(ExpedienteExpandido expedienteExpandido) {
		// FIXME AQUI SE DEBERIAN VALIDAR LOS DATOS
		return "CORRECTO";
	}

	@Override
	public String crearHistorico(HistoricoTramitacion historicoTramitacion) {
		int respuesta = historicoTramitacionDAO.createHistoricoTramitacion(historicoTramitacion);
		if (respuesta == 0) {
			return "INCORRECTO";
		}
		else {
			return historicoTramitacion.getCodExpediente();
		}
		
	}
	@Override
	public SubExpediente insertarSubExpediente(SubExpediente subExpediente) {
		return subExpedienteDAO.insertSubExpediente(subExpediente);
	}
}
