package es.alten.diputacion.add.servicios.impl;
import java.util.Date;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import es.alten.diputacion.add.abstraccion.HistoricoDao;
import es.alten.diputacion.add.modelo.Historico;
import es.alten.diputacion.add.servicios.HistoricoServicio;
import es.alten.diputacion.add.util.add.SecuenciadorProvicional;

@Transactional(propagation=Propagation.MANDATORY)
public class HistoricoServicioImpl implements HistoricoServicio{
	private HistoricoDao daoHistorico;
	public HistoricoDao getDaoHistorico() {
		return daoHistorico;
	}
	public void setDaoHistorico(HistoricoDao daohistorico) {
		this.daoHistorico = daohistorico;
	}
	@Override
	public void guardarHistorico(String codUsuario,String codOperacion) {
		Historico historico = new Historico();
		historico.setCodHistorico(SecuenciadorProvicional.getSecuencia());
		historico.setCodOperacion(codOperacion);
		historico.setCodUsuario(codUsuario);
		historico.setFechaRegistro(new Date());
		daoHistorico.insertHistorico(historico);
	}
}
