package es.alten.diputacion.add.servicios.impl;

import java.math.BigDecimal;

import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.PersonaDao;
import es.alten.diputacion.add.modelo.Persona;
import es.alten.diputacion.add.servicios.PersonaServicio;


public class PersonaServicioImpl implements PersonaServicio {
	Logger log = Logger.getLogger(PersonaServicioImpl.class);
	private PersonaDao personaDAO;
	
	public PersonaDao getPersonaDAO() {
		return personaDAO;
	}

	public void setPersonaDAO(PersonaDao personaDAO) {
		this.personaDAO = personaDAO;
	}

	@Override
	public Persona consultaRepresentanteporInteresado(String codInteresado) {
		
		Persona persona = personaDAO.consultaPersonaByCodigo(codInteresado);
		return persona;
	}
	
	@Override
	public Persona consultaInteresadoByCodigo( String codInteresado ) {
		Persona persona = personaDAO.consultaPersonaByCodigo(codInteresado);
		return persona;
	}

	@Override
	public int modificarPersona(Persona persona) {
		int respuesta = personaDAO.updatePersona(persona);
		return respuesta;
	}

	@Override
	public String crearInteresado(Persona interesado) {
		
		//String codInteresado = "0005";
		//interesado.setCodigo(codInteresado);
		interesado.setTipo("1");
		interesado.setPoblacion(new BigDecimal(0));
		int respuesta = personaDAO.createPersona(interesado);
		if (respuesta == 0) {
			return "INCORRECTO";
		}
		else {
			//return interesado.getCodigo();
			String codInteresado = Integer.toString(respuesta);
			return codInteresado;
		}
	}

	@Override
	public String crearRepresentante(Persona representante) {
		//String codRepresentante = "0004";
		//representante.setCodigo(codRepresentante);
		representante.setTipo("0");
		representante.setPoblacion(new BigDecimal(0));
		int respuesta = personaDAO.createPersona(representante);
		if (respuesta == 0) {
			return "INCORRECTO";
		}
		else {
			String codRepresentante = Integer.toString(respuesta);
			return codRepresentante;
			//return representante.getCodigo();
		}
	}

}
