package es.alten.diputacion.add.servicios.request;
import java.util.ArrayList;
import java.util.List;

import es.alten.diputacion.add.aspectos.HistoricoRequest;
import es.alten.diputacion.add.aspectos.RequestServicio;
import es.alten.diputacion.add.aspectos.ValidableRequest;
import es.alten.diputacion.add.servicios.HistoricoServicio;
import es.alten.diputacion.add.util.add.ValidacionUtil;

public class InActivacionUOrganicas implements HistoricoRequest,ValidableRequest{
	public static final String COD_USUARIO_NO_NULO="es.alten.diputacion.add.servicios.request.InActivacionUOrganicas.COD_USUARIO_NO_NULO";
	public static final String LISTA_VACIA="es.alten.diputacion.add.servicios.request.InActivacionUOrganicas.LISTA_VACIA";
	private boolean activar;
	private String codigoUsuario;
	private List<String> listaUnidadesOrganizativas;

	@Override
	public void validar() {
		ValidacionUtil.validarCampoNoNulo(codigoUsuario,COD_USUARIO_NO_NULO);
		ValidacionUtil.validaListaVacia(listaUnidadesOrganizativas,LISTA_VACIA);
	}
	
	

	public void setCodigoUsuario(String codigoUsuario) {
		this.codigoUsuario = codigoUsuario;
	}

	public List<String> getListaUnidadesOrganizativas() {
		if(listaUnidadesOrganizativas==null){
			listaUnidadesOrganizativas=new ArrayList<String>();
		}
		return listaUnidadesOrganizativas;
	}

	public boolean isActivar() {
		return activar;
	}

	public void setActivar(boolean activar) {
		this.activar = activar;
	}



	@Override
	public String getCodigoUsuario() {
		// TODO Auto-generated method stub
		return codigoUsuario;
	}
}
