package es.alten.diputacion.add.tags;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.SubtipologiaDao;
import es.alten.diputacion.add.abstraccion.TipologiaDao;
import es.alten.diputacion.add.abstraccion.TramiteDao;
import es.alten.diputacion.add.modelo.Subtipologia;
import es.alten.diputacion.add.modelo.Tipologia;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.struts.ComboForm;
import es.alten.diputacion.add.util.UtilidadesCronos;

@SuppressWarnings("serial")
public class TagCargarCombos extends TagSupport{
	
	private String codTipologia;
	private String codSubtipologia;
	
	public String getCodTipologia() {
		return codTipologia;
	}

	public void setCodTipologia(String codTipologia) {
		this.codTipologia = codTipologia;
	}

	public String getCodSubtipologia() {
		return codSubtipologia;
	}

	public void setCodSubtipologia(String codSubtipologia) {
		this.codSubtipologia = codSubtipologia;
	}

	private static Logger LOGGER = Logger.getLogger(TagCargarCombos.class);
	
	@Override
	public int doStartTag() throws JspException {
		try {
			TramiteDao tramiteDAO = (TramiteDao) UtilidadesCronos.getContextoSpring().getBean("tramiteDAO", TramiteDao.class);
			SubtipologiaDao subtipologiaDAO = (SubtipologiaDao) UtilidadesCronos.getContextoSpring().getBean("subtipologiaDAO", SubtipologiaDao.class);
			TipologiaDao tipologiaDAO = (TipologiaDao) UtilidadesCronos.getContextoSpring().getBean("tipologiaDAO", TipologiaDao.class);
			Usuario usuario = (Usuario) pageContext.getSession().getAttribute("usuario");
			
			ComboForm comboForm = new ComboForm();
			comboForm.setCodSubtipologia(this.codSubtipologia);
			comboForm.setCodTipologia(this.codTipologia);
						
			List<Tramite> tramites = tramiteDAO.consultarTramitesUsuario(usuario.getCodigo());
				
				for (Tramite tramite : tramites){
					
					Subtipologia subtipologia = subtipologiaDAO.consultaSubtipologiaPorTramite(tramite.getCodSubtipologia());
					tramite.setSubtipologia(subtipologia);
					Tipologia tipologia = tipologiaDAO.consultaTipologiaPorSubtipologia(subtipologia.getCodTipologia());
					tramite.setTipologia(tipologia);	
				}
			
			List<Tipologia> listaTipologia = new ArrayList<Tipologia>();
			for (Tramite tramite : tramites){
				Tipologia nuevaTipologia = tramite.getTipologia();
				if(listaTipologia.indexOf(nuevaTipologia)==-1){
					listaTipologia.add(nuevaTipologia);
				}
			}
			
			if (this.getCodTipologia()!=null && this.getCodSubtipologia()!= null){			
			
				if (!(this.getCodTipologia().equals("-1")) && !(this.getCodSubtipologia().equals("-2"))){ 
					
					List<Subtipologia> listaSubtipologia = new ArrayList<Subtipologia>();
					for (Tramite tramite : tramites){
						Subtipologia nuevaSubtipologia = tramite.getSubtipologia();
						if(listaSubtipologia.indexOf(nuevaSubtipologia)==-1 && (tramite.getTipologia().getCodTipologia().equals(this.getCodTipologia()))){
							listaSubtipologia.add(nuevaSubtipologia);
						}
					}
					
					List<Tramite> listaTramites = new ArrayList<Tramite>();
					for (Tramite tramite : tramites){
	
						if(listaTramites.indexOf(tramite)==-1 && (tramite.getSubtipologia().getCodSubtipologia().equals(this.getCodSubtipologia()))){
							listaTramites.add(tramite);
						}
					}
					
					pageContext.getRequest().setAttribute("listaSubtipologia", listaSubtipologia);
					pageContext.getRequest().setAttribute("listaTipologia", listaTipologia);
					pageContext.getRequest().setAttribute("listaTramites", listaTramites);
					pageContext.getRequest().setAttribute("comboForm", comboForm);
				}
				
				else if (!(this.getCodTipologia().equals("-1"))) {
					
					List<Subtipologia> listaSubtipologia = new ArrayList<Subtipologia>();
					for (Tramite tramite : tramites){
						Subtipologia nuevaSubtipologia = tramite.getSubtipologia();
						if(listaSubtipologia.indexOf(nuevaSubtipologia)==-1 && tramite.getTipologia().getCodTipologia().equals(comboForm.getCodTipologia())){
							listaSubtipologia.add(nuevaSubtipologia);
						}
					}
					pageContext.getRequest().setAttribute("listaSubtipologia", listaSubtipologia);
					pageContext.getRequest().setAttribute("listaTipologia", listaTipologia);
					pageContext.getRequest().setAttribute("comboForm", comboForm);
				}		
							
			}
			
			pageContext.getRequest().setAttribute("listaTipologia", listaTipologia);

		}catch (Exception e) {
			LOGGER.error("Ha habido un error al la lista de combos dependientes", e);
		}
		return super.doStartTag();
	}

}
