package es.alten.diputacion.add.tags;

import java.util.List;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.ComboDao;
import es.alten.diputacion.add.modelo.Combo;
import es.alten.diputacion.add.modelo.RegistroCombo;
import es.alten.diputacion.add.util.UtilidadesCronos;

@SuppressWarnings("serial")
public class TagCargarCombosGeneral extends TagSupport{
	
	private int idRegistro;	
	
	public int getIdRegistro() {
		return idRegistro;
	}

	public void setIdRegistro(int idRegistro) {
		this.idRegistro = idRegistro;
	}

	private static Logger LOGGER = Logger.getLogger(TagCargarCombosGeneral.class);
	
	@Override
	public int doStartTag() throws JspException {
		try {
			ComboDao comboDAO =  (ComboDao) UtilidadesCronos.getContextoSpring().getBean("comboDAO", ComboDao.class);

			List<RegistroCombo> registros = comboDAO.consultarTodosRegistrosPorCombo(this.idRegistro);
			Combo combo = new Combo();
			combo.setRegistros(registros);
				
			pageContext.getRequest().setAttribute("combo", combo);

		}catch (Exception e) {
			LOGGER.error("Ha habido un error al cargar el combo" + this.idRegistro + "de la lista de combos", e);
		}
		return super.doStartTag();
	}


}
