package es.alten.diputacion.add.tags;

import java.util.List;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.apache.log4j.Logger;


import es.alten.diputacion.add.abstraccion.TramiteDao;
import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.util.UtilidadesCronos;

@SuppressWarnings("serial")
public class TagCargarTramites extends TagSupport{

	private static Logger LOGGER = Logger.getLogger(TagCargarTramites.class);
	
	@Override
	public int doStartTag() throws JspException {
		try {
			TramiteDao tramiteDAO = (TramiteDao) UtilidadesCronos.getContextoSpring().getBean("tramiteDAO", TramiteDao.class);
			Usuario usuario = (Usuario) pageContext.getSession().getAttribute("usuario");
			
					
			List<Tramite> tramites = tramiteDAO.consultarTramitesUsuario(usuario.getCodigo());

			
			pageContext.getRequest().setAttribute("listaTramites", tramites);
				
		}catch (Exception e) {
			LOGGER.error("Ha habido un error al la lista de trmites del usuario", e);
		}
		return super.doStartTag();
	}

}
