package es.alten.diputacion.add.tags;

import java.util.List;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import org.apache.log4j.Logger;

import es.alten.diputacion.add.abstraccion.AsentamientoDao;
import es.alten.diputacion.add.abstraccion.UOrganizativaDao;
import es.alten.diputacion.add.modelo.Asentamiento;
import es.alten.diputacion.add.modelo.UOrganizativa;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.util.UtilidadesCronos;

@SuppressWarnings("serial")
public class TagCargarUnidades extends TagSupport{

	private static Logger LOGGER = Logger.getLogger(TagCargarUnidades.class);
	
	@Override
	public int doStartTag() throws JspException {
		try {					
			UOrganizativaDao daoUOrganizativa = (UOrganizativaDao) UtilidadesCronos.getContextoSpring().getBean("daoUOrganizativa", UOrganizativaDao.class);
			AsentamientoDao daoAsentamiento = (AsentamientoDao) UtilidadesCronos.getContextoSpring().getBean("daoAsentamiento", AsentamientoDao.class);
			Usuario usuario = (Usuario) pageContext.getSession().getAttribute("usuario");
			
			List<UOrganizativa> unidades = daoUOrganizativa.consultarUOrganizativaUsuario(usuario.getCodigo());
			
			for (UOrganizativa unidad : unidades) {

				List<Asentamiento> asentamientos = daoAsentamiento.consultaAsentamientoPorUnidadOrganica(unidad.getCodUOrganizativa());
				unidad.setAsentamientos(asentamientos);
			}
			
			pageContext.getRequest().setAttribute("listaUnidades", unidades);
				
		}catch (Exception e) {
			LOGGER.error("Ha habido un error al la lista de unidades", e);
		}
		return super.doStartTag();
	}

}
