package es.alten.diputacion.add.util;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.List;

import es.alten.diputacion.add.modelo.Asentamiento;
import es.alten.diputacion.add.modelo.Documento;
import es.alten.diputacion.add.modelo.Expediente;
import es.alten.diputacion.add.modelo.Tramite;

public class CSVAddUtils {
	
	public static byte[] obtenerCSVTramite(List<Tramite> tramites) {
		
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] archivo = null;
		
		for (Tramite tramite: tramites){
		
			try {
				
				bos.write(((String) isVacio("getCodigoTramite", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getNombreTramite", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getDescTramite", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodSubtipologia", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getTema", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getFamilia", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getSubfamilia", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getArea", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getAdministracionComponente", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getNivelProteccion", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getPublicidad", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getEvalSeleccionEliminacion", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodEntidad", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodUOrganizativaDestino", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getClasificacionArchivo", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaBaja", tramite)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaRegistro", tramite)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getEliminado", tramite)).getBytes());
				bos.write(";".getBytes());
				bos.write("\n".getBytes());
				
				
			} catch (IOException e) {
	
				e.printStackTrace();
			}
			
		}
		
		try {
			bos.flush();
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		archivo = bos.toByteArray();
		
	return archivo;
	
	}
	
	public static byte[] obtenerCSVDocumento(List<Documento> documentos) {
		
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] archivo = null;
		
		for (Documento documento: documentos){
		
			try {
				
				bos.write(((String) isVacio("getCodDocumento", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodExpediente", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getSoporte", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getNivelDescripcion", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getTituloDocumento", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getProductor", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getUnidadProductora", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaCaducidad", documento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaDocumento", documento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodInteresado", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodAsentamiento", documento)).getBytes());
				bos.write(";".getBytes());
				bos.write("\n".getBytes());
				
				
			} catch (IOException e) {
	
				e.printStackTrace();
			}
			
		}
		
		try {
			bos.flush();
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		archivo = bos.toByteArray();
		
	return archivo;
	
	}
	
	public static byte[] obtenerCSVExpediente(List<Expediente> expedientes) {
		
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] archivo = null;
		
		for (Expediente expediente: expedientes){
		
			try {
				
				bos.write(((String) isVacio("getCodExpediente", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodUorganizativa", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodTransitoExp", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaRegistroExp", expediente)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaBajaExp", expediente)).toString().getBytes());
				bos.write(";".getBytes());				
				bos.write(((String) isVacio("getCodEstado", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodCategoria", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodSubcategoria", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getTipoExpediente", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getNivelDescripcion", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getTituloExpediente", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getPoliticaEvaluacion", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getDescripcion", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getObservaciones", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getPublicidad", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodTramite", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodUsuario", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getNivelProtecDatos", expediente)).getBytes());
				bos.write(";".getBytes());	
				bos.write(((String) isVacio("getEstadoTramitacion", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodInteresado", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodRepresentante", expediente)).getBytes());
				bos.write(";".getBytes());
				bos.write("\n".getBytes());
				
				
			} catch (IOException e) {
	
				e.printStackTrace();
			}
			
		}
		
		try {
			bos.flush();
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		archivo = bos.toByteArray();
		
	return archivo;
	
	}
	
public static byte[] obtenerCSVAsentamientos(List<Asentamiento> asentamientos) {
		
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		byte[] archivo = null;
		
		for (Asentamiento asentamiento: asentamientos){
		
			try {
				
				bos.write(((String) isVacio("getCodAsentamiento", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getAsunto", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaRegistro", asentamiento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaDocumento", asentamiento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaPresentacion", asentamiento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaAceptacion", asentamiento)).toString().getBytes());
				bos.write(";".getBytes());
				bos.write((isVacio("getFechaRechazo", asentamiento)).toString().getBytes());
				bos.write(";".getBytes());				
				bos.write(((String) isVacio("getTipoAsentamiento", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getViaPresentacion", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getSoporteFisico", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getUrgente", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getFaltaDocEscaner", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getObservaciones", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodUOrganizativa", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodEstado", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodExpediente", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getCodInteresado", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write(((String) isVacio("getMotivoRechazo", asentamiento)).getBytes());
				bos.write(";".getBytes());
				bos.write("\n".getBytes());				
				
			} catch (IOException e) {
	
				e.printStackTrace();
			}
			
		}
		
		try {
			bos.flush();
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		archivo = bos.toByteArray();
		
	return archivo;
	
	}
	
	public byte[] convertirFileaByte (File archivo){
	
		FileInputStream entrada = null;
		ByteArrayOutputStream salida = null;
		byte[] buffer = new byte[1024];
		byte[] datos = null;
		try {
		entrada = new FileInputStream(archivo);
		salida = new ByteArrayOutputStream();

		int numeroBytes = 0;
		while ((numeroBytes = entrada.read(buffer)) != -1) {
			salida.write(buffer, 0, numeroBytes);
		}

		datos = salida.toByteArray();
		entrada.close();
		salida.close();
		} catch (Exception e) {
		e.printStackTrace();
		}

		return datos;
		
	}
	
	public static Object isVacio (String metodo, Object objeto){		
			try {
				// Invoca el metodo para obtener el valor
				Method method = objeto.getClass().getMethod(metodo, (Class<?>[]) null);
				Object valor = method.invoke(objeto, new Object[0]);
				if(valor != null){
					return valor;
				}
				else {
					return "";
				}
			} catch (Exception e) {
				System.out.println("Se ha producido un error");
			}
			return "";

	}
}
