/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package es.alten.diputacion.add.util;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * Esta clase esta pensada para facilitarnos las taras de formatear desde
 * cadenas a fechas, a moneda... y viceversa
 * 
 * @author jluis.martinez
 */
public class FormatUtils {

	private SimpleDateFormat simpleDateFormat = new SimpleDateFormat(
			"dd/MM/yyyy");
	private DecimalFormat decimalFormat;

	public String secuencia4ceros(long secuencia) {
		decimalFormat = new DecimalFormat("0000");
		return decimalFormat.format(secuencia);
	}

	public String stringFecha(Date fecha) {
		if (fecha != null) {
			return simpleDateFormat.format(fecha);
		}
		return "";
	}

	public String getHoy() {
		return stringFecha(Calendar.getInstance().getTime());
	}

	public int annoActual() {
		return Calendar.getInstance().get(Calendar.YEAR);
	}

	public BigDecimal numericImporte(String _importe) {
		BigDecimal bg = new BigDecimal(0);
		try {
			String value = "";
			for (int i = 0; i < _importe.length(); i++) {
				if (_importe.charAt(i) != '.') {
					value = value.concat(_importe.substring(i, i + 1));
				}
			}
			value = value.replaceAll(",", ".");
			double valor = Double.parseDouble(value);
			return new BigDecimal(valor);
		} catch (NumberFormatException nfe) {
			UtilidadesCronos.getExcepcionLanzada().addError(
					"es.alten.cronos.injuve.geexpediente.importe.error.numero");
		}
		return bg;
	}

	public String formatoMonedaPantalla(String importe) {
		try {
			double cantidad = Double.parseDouble(importe);
			NumberFormat formato = NumberFormat.getInstance();
			return formato.format(cantidad);
		} catch (NumberFormatException nfe) {
			return "error";
		}
	}

	public Object truncar(String parameter) {
		parameter = parameter.replace('.', ',');
		if (parameter.indexOf(",") > 0) {
			parameter = parameter.substring(0, parameter.indexOf(",") + 3);
		}
		return parameter;
	}
}
