package es.alten.diputacion.add.web.struts;

import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.servicios.UOrganizativaServicio;
import es.alten.diputacion.add.servicios.request.InActivacionUOrganicas;

public class ActivarUOAction extends BaseAction{
	private Logger log = Logger.getLogger(ActivarUOAction.class);
	private UOrganizativaServicio unidadOrganizativaServicio;
	
	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
	}
	@Override
	protected ActionForward procesar(ActionMapping mapping,ActionForm objetoModelo, HttpServletRequest request,HttpServletResponse response) {
		String[] listaCodUO = request.getParameterValues("listaCodUO");
		String[] listaUOSeleccionadas = request.getParameterValues("listaUOSeleccionadas");
		String cambioEstado = request.getParameter("cambioEstado");
		ArrayList<String> listaCodUOSeleccionadas = getCodUOSeleccionadas(listaCodUO, listaUOSeleccionadas);
		
		try {
				InActivacionUOrganicas in = new InActivacionUOrganicas();
				in.setCodigoUsuario(((Usuario) request.getSession().getAttribute(LoginAction.USUARIO)).getCodigo());
				in.getListaUnidadesOrganizativas().addAll(listaCodUOSeleccionadas);
				if(cambioEstado.equals("Activar")){
					in.setActivar(true);
					unidadOrganizativaServicio.activacionMasivaDeUOrganicas(in);
				}else if(cambioEstado.equals("Desactivar")){
					in.setActivar(false);
					unidadOrganizativaServicio.activacionMasivaDeUOrganicas(in);
				}
		}
		catch(Exception e){
			log.error("CASCO",e);;
			return mapping.findForward("carga_inicial");
		}
		return mapping.findForward("carga_inicial");
	}
	
	private ArrayList<String> getCodUOSeleccionadas(String[] listaCodUO,String[] listaUOSeleccionadas){
		ArrayList<String> nuevaListaCodUO = new ArrayList<String>();
		for(int i=0; i<listaCodUO.length; i++){
			if(listaUOSeleccionadas[i].equals("true")){
				nuevaListaCodUO.add(listaCodUO[i]);
			}
		}
		return nuevaListaCodUO;
	}

	public UOrganizativaServicio getUnidadOrganizativaServicio() {
		return unidadOrganizativaServicio;
	}

	public void setUnidadOrganizativaServicio(
			UOrganizativaServicio unidadOrganizativaServicio) {
		this.unidadOrganizativaServicio = unidadOrganizativaServicio;
	}
}
