package es.alten.diputacion.add.web.struts;

import java.util.Date;
import java.util.ResourceBundle;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.TramiteConTipologiaGestionableResultado;
import es.alten.diputacion.add.modelo.resultado.UsuarioResultado;
import es.alten.diputacion.add.modelo.struts.AltaTramiteForm;
import es.alten.diputacion.add.modelo.struts.AltaUsuarioForm;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.servicios.AdministracionTramiteServicio;
import es.alten.diputacion.add.servicios.AdministracionUsuarioServicio;
import es.alten.diputacion.add.util.add.FactoriaResourceBundle;


public class AltaUsuarioAjaxAction extends BaseAction{
	
	Logger log = Logger.getLogger(AltaUsuarioAjaxAction.class);
	private static ResourceBundle rb = FactoriaResourceBundle.getResourceBundle();
	public static final String MENSAJE_NOMBRE_NULL="es.alten.diputacion.add.web.struts.AltaUsuarioAjaxAction.MENSAJE_NOMBRE_NULL";
	public static final String MENSAJE_PASSWORD_NULL="es.alten.diputacion.add.web.struts.AltaUsuarioAjaxAction.MENSAJE_PASSWORD_NULL";
	public static final String MENSAJE_ROL_NULL="es.alten.diputacion.add.web.struts.AltaUsuarioAjaxAction.MENSAJE_ROL_NULL";

	private AdministracionUsuarioServicio administracionUsuarioServicio;

	public void setAdministracionUsuarioServicio(
			AdministracionUsuarioServicio administracionUsuarioServicio) {
		this.administracionUsuarioServicio = administracionUsuarioServicio;
	}

	public AdministracionUsuarioServicio getAdministracionUsuarioServicio() {
		return administracionUsuarioServicio;
	}

	
	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		
		log.info("############################ ALTA USUARIO ACTION");
		AltaUsuarioForm usuarioForm = (AltaUsuarioForm)objetoModelo;
		Usuario usuario = new Usuario();
		usuario.setNombre(usuarioForm.getNombre());
		usuario.setRol(usuarioForm.getRol());
		usuario.setPassword(usuarioForm.getPassword());
		usuario.setFechaAlta(new Date());
		usuario.setEliminado("N");
		
		//TramiteConTipologiaGestionableResultado tramiteInsertado = new TramiteConTipologiaGestionableResultado();
		UsuarioResultado usuarioInsertado = new UsuarioResultado();
		
		try {
			
			usuarioInsertado = administracionUsuarioServicio.altaUsuario(usuario);
//			responderPeticionAjax(response, tramiteModificado);
			
		}
		catch(IllegalArgumentException e){
			if(e.getMessage().equals(Usuario.NOM_NULL)){
			
				usuarioInsertado.setMensajeDeError(rb.getString(MENSAJE_NOMBRE_NULL));
				usuarioInsertado.setError(true);
			}
			else if(e.getMessage().equals(Usuario.PASSWORD_NULL)){
				usuarioInsertado.setMensajeDeError(rb.getString(MENSAJE_PASSWORD_NULL));
				usuarioInsertado.setError(true);
			}
			else if(e.getMessage().equals(Usuario.ROL_NULL)){
				usuarioInsertado.setMensajeDeError(rb.getString(MENSAJE_ROL_NULL));
				usuarioInsertado.setError(true);
			}
		}
		
		responderPeticionAjax(response, usuarioInsertado);
		return null;
	}

	
}
