package es.alten.diputacion.add.web.struts;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.springframework.jdbc.UncategorizedSQLException;
import org.springframework.orm.hibernate3.HibernateJdbcException;
import org.springframework.transaction.CannotCreateTransactionException;

import com.google.gson.Gson;

import es.alten.diputacion.add.excepcion.CronosLoginException;
import es.alten.diputacion.add.excepcion.CronosPermisosException;
import es.alten.diputacion.add.excepcion.CronosRuntimeException;
import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.util.Forwards;
import es.alten.diputacion.add.util.ListaNombres;
import es.alten.diputacion.add.util.UtilidadesCronos;

/**
 * Base action nos permitir cargar el contexto de spring una vez que sea
 * inicializado el servlet de struts.
 * 
 * Ser la encargada de recibir todas las peticiones y delagar en los hijos para 
 * procesar la accion determinada en cada caso.
 * 
 * Ser la encargada de controlar todas las excepciones de la aplicacion.
 *  
 * @author Pedro Garcia
 */
public abstract class BaseAction extends Action {
	private Logger log = Logger.getLogger(BaseAction.class);
	private static final Log logger = LogFactory.getLog(BaseAction.class);
/*
	@Override
	public void setServlet(ActionServlet actionServlet) {
		// Inicializacin del servlet de Struts
		super.setServlet(actionServlet);
		// Carga del contexto de Spring
		if (actionServlet != null) {
			ServletContext context = actionServlet.getServletContext();
			UtilidadesInjuve.contextoSpring = WebApplicationContextUtils
					.getRequiredWebApplicationContext(context);
		}

	}
	*/
	@Override
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		Boolean ejecutarFinally = Boolean.TRUE;
		try {

			// if (UtilidadesInjuve.getExcepcionLanzada() != null){
			// throw UtilidadesInjuve.getExcepcionLanzada();
			// }
			// TODO Falta controlar que todas las peticiones sean POST. Si
			// alguna es del tipo GET mostrar pgina
			// de error.

			// Obtenemos el nombre de la accin y lo preparamos para compararlo
			// con las funciones almacenadas en la base de datos.
			String nombreAccion = this.getClass().getName().substring(
					this.getClass().getName().lastIndexOf('.') + 1);

			Usuario usuario = (Usuario) request.getSession().getAttribute(
					ListaNombres.UsuarioLogado.getDescripcion());

//			FiltroPrivilegiosUsuario filtroPrivilegiosUsuario = (FiltroPrivilegiosUsuario) UtilidadesInjuve.contextoSpring.getBean("filtroPrivilegiosUsuario");

//			String nombreOperacion = request.getParameter("submit");
//			
//			if(nombreOperacion== null || "".equals(nombreOperacion)){
//				nombreOperacion = request.getParameter("opcion");
//			}
//			
//			
//			if (("ForwardAction".equals(nombreAccion))
//					&& ((request.getRequestURI().contains("/login.htm")) || (request
//							.getRequestURI().contains("/error.htm")))
//					|| ("DeslogadoAction".equals(nombreAccion))
//					|| ("IniciarResetPasswordAction".equals(nombreAccion))
//					|| ("EjecutarResetPasswordAction".equals(nombreAccion))) {
//
//				// Agregar el usuario al hilo de ejecucin
//				UtilidadesInjuve.setUsuarioLogado(usuario);
//
//				// Lanzar action
//				return procesar(mapping, actionForm, request, response);
//			} else if ((!"LogadoAction".equals(nombreAccion))
//					&& (!"CambioPasswordAction".equals(nombreAccion))
//					&& (!"InicioAction".equals(nombreAccion))
//					&& (usuario == null)) {
//				// Puede darse el error tras un tiempo de inactividad por parte
//				// del usuario en la aplicacin, o por
//				// que el usuario no tiene acceso a ciertas acciones en la
//				// propia aplicacin
//				// TODO Controlar cada una de las excepciones posibles
//				throw new CronosLoginException("es.alten.cronos.usuario.error");
//			}

			UtilidadesCronos.setUsuarioLogado(usuario);
			
//			if(!"LogadoAction".equals(nombreAccion)){
//				filtroPrivilegiosUsuario.autenticar(UtilidadesInjuve.getRolUsuarioLogado(), nombreAccion, nombreOperacion);
//			}
			
			return procesar(mapping, actionForm, request, response);
		} catch (CronosPermisosException exception) {
			logger.warn(exception);
			ejecutarFinally = Boolean.FALSE;
			Map<String, Object> mensaje = UtilidadesCronos.crearMap();
			UtilidadesCronos.insertarMensaje(mensaje, exception.getMessage());
			request.setAttribute(UtilidadesCronos.LISTA_MENSAJES, mensaje
					.get(UtilidadesCronos.LISTA_MENSAJES));
			return mapping.findForward("permisos");
			
		} catch (CronosValidacionException exception) {
			logger.warn(exception);
			ejecutarFinally = Boolean.FALSE;
			Map<String, Object> mensaje = UtilidadesCronos.crearMap();
			UtilidadesCronos.insertarMensaje(mensaje, exception.getMessage());
			request.setAttribute(UtilidadesCronos.LISTA_MENSAJES, mensaje
					.get(UtilidadesCronos.LISTA_MENSAJES));
			return mapping.findForward("error");
			
		} catch (CronosLoginException exception) {
			logger.warn(exception);
			Map<String, Object> mensaje = UtilidadesCronos.crearMap();
			UtilidadesCronos.insertarMensaje(mensaje, exception.getMessage());
			request.setAttribute(UtilidadesCronos.LISTA_MENSAJES, mensaje
					.get(UtilidadesCronos.LISTA_MENSAJES));
			return mapping.findForward("errorLogin");
		} catch (CronosRuntimeException exception) {
			logger.warn(exception);
			Map<String, Object> mensaje = UtilidadesCronos.crearMap();
			UtilidadesCronos.insertarMensaje(mensaje, exception.getMessage());
			request.setAttribute(UtilidadesCronos.LISTA_MENSAJES, mensaje
					.get(UtilidadesCronos.LISTA_MENSAJES));
			return mapping.findForward("error");
		} catch (CannotCreateTransactionException transactionException) {
			logger.warn(transactionException);
//			transactionException.printStackTrace();
			return buscarErrorOracle(request, mapping, transactionException);
		} catch (HibernateJdbcException jdbcException) {
			logger.warn(jdbcException);
//			jdbcException.printStackTrace();
			return buscarErrorOracle(request, mapping, jdbcException);
		} catch (UncategorizedSQLException exception){
			logger.warn(exception);
			int error = ((java.sql.SQLException) exception.getCause()).getErrorCode();
			if(error==12899){
				return procesarErrores(request, mapping, "es.alten.cronos.oracle.ORA-12899");
			}else{
				return procesarErrores(request, mapping, "errores");
			}
		} catch (Throwable exception) {
			logger.error(exception);
			return procesarErrores(request, mapping, "errores");
		} finally {
			if(ejecutarFinally){
				if (request.getAttribute(UtilidadesCronos.LISTA_MENSAJES) != null) {
					try {
						delegarError((BaseForm) actionForm, request, response);
					} catch (Throwable exception) {
						logger.error(exception);
//						exception.printStackTrace();
//						exception.printStackTrace();
						return mapping.findForward("inicio");
					}
				}
			}
		}

	}

	/**
	 * 
	 * Metodo llamado para contralar cualquier error.
	 */
	protected abstract void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response);

	/**
	 * 
	 * Se encargar de ejecutar la accion solicitada.
	 */
	protected abstract ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response);

	private ActionForward buscarErrorOracle(HttpServletRequest request,
			ActionMapping mapping, Throwable throwable) {
		Throwable error = throwable;
		while (error != null) {
			if (error.getMessage().contains("ORA")) {
				String errorOracle = error.getMessage().substring(0,
						error.getMessage().indexOf(':'));
				return procesarErrores(request, mapping,
						"es.alten.cronos.oracle." + errorOracle);
			}
			error = error.getCause();
		}
		return procesarErrores(request, mapping, "errores");
	}

	private ActionForward procesarErrores(HttpServletRequest request,
			ActionMapping mapping, String error) {
		Map<String, Object> mensaje = UtilidadesCronos.crearMap();
		UtilidadesCronos.insertarMensaje(mensaje, error);
		request.setAttribute(UtilidadesCronos.LISTA_MENSAJES, mensaje
				.get(UtilidadesCronos.LISTA_MENSAJES));
		// System.out.println(mensaje.get(UtilidadesInjuve.LISTA_MENSAJES));
		if (error.contains("es.alten.cronos.oracle.ORA-00942")) {
			return mapping.findForward(Forwards.ErrorJDBC.getDescripcion());
		}
		return mapping.findForward(Forwards.Error.getDescripcion());
	}
	/**@author Alberto Pla Martin
	 * Metodo que se encarga de gestionar el flujo de salida de una peticion ajax serializando a formato json
	 * el bean que servira para contener la informacion de respuesta
	 * @param response contexto response 
	 * @param bean Un bean que servira de contenedor para enviar los datos de respuesta
	 */
	protected void responderPeticionAjax(HttpServletResponse response, Object bean){
		try {
			if(bean==null){
				throw new IllegalArgumentException("El bean no puede ser null");
			}
			if(response==null){
				throw new IllegalArgumentException("response no puede ser null");
			}
			response.setContentType("text/x-json;charset=UTF-8");
			response.setHeader("Cache-Control", "no-cache");
			Gson parserJSON = new Gson();
			PrintWriter out = response.getWriter();
			out.println(parserJSON.toJson(bean));
			out.close();
			out.flush();
		} catch (IOException e) {
			log.fatal("############## ERROR EN RESPUESTA AJAX ################",e);
		}
	}
	/**@author Alberto Pla Martin
	 * Metodo que se encarga de gestionar el flujo de salida de una peticion ajax que no necesita responder nada
	 * @param response contexto response 
	 */
	/*
	protected void responderPeticionAjax(HttpServletResponse response){
		try {
			if(response==null){
				throw new IllegalArgumentException("response no puede ser null");
			}
			response.setContentType("text/x-json;charset=UTF-8");
			response.setHeader("Cache-Control", "no-cache");
			PrintWriter out = response.getWriter();
			out.close();
			out.flush();
		} catch (IOException e) {
			log.fatal("############## CASCO RESPUESTA AJAX ################",e);
		}
	}*/
}
