package es.alten.diputacion.add.web.struts;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.DocumentoForm;

import es.alten.diputacion.add.modelo.resultado.DocumentoResultado;
import es.alten.diputacion.add.servicios.DocumentoServicio;

public class BusquedaDocumentosAction extends BaseAction {
	
	private DocumentoServicio documentoServicio;
	
	public DocumentoServicio getDocumentoServicio() {
		return documentoServicio;
	}

	public void setDocumentoServicio(DocumentoServicio documentoServicio) {
		this.documentoServicio = documentoServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		DocumentoForm documentoForm = (DocumentoForm) objetoModelo;
		DocumentoResultado resultado = documentoServicio.validarDocumento(documentoForm);
		resultado.setDocumento(documentoForm);
	
		if ("Buscar".equalsIgnoreCase(request.getParameter("submit"))) {			
		
			switch(resultado.getConfirmacion()){
			case CORRECTO: 
				
				if (documentoForm.getModo().equals("AND")){				
					DocumentoResultado resultadoDoc = documentoServicio.consultarDocumentos(resultado);
					request.setAttribute("resultadoDoc", resultadoDoc);
				}
				else if (documentoForm.getModo().equals("OR")){				
					DocumentoResultado resultadoDoc = documentoServicio.consultarDocumentosOr(resultado);
					request.setAttribute("resultadoDoc", resultadoDoc);
				}
				else if (documentoForm.getModo().equals("NOT")){				
					DocumentoResultado resultadoDoc = documentoServicio.consultarDocumentosNot(resultado);
					request.setAttribute("resultadoDoc", resultadoDoc);
				}
				
				return mapping.findForward("correcto");
			}
		
		}
		
		return mapping.findForward("error");
		
		}

}
