package es.alten.diputacion.add.web.struts;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


import es.alten.diputacion.add.modelo.ExpedienteExpandido;
import es.alten.diputacion.add.modelo.HistoricoTramitacion;
import es.alten.diputacion.add.modelo.resultado.ExpedienteExpandidoResultado;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.ExpedienteExpandidoForm;
import es.alten.diputacion.add.servicios.ExpedienteServicio;
import es.alten.diputacion.add.servicios.PersonaServicio;



public class ConsultaExpedientesCodigoAjaxAction extends BaseAction{
	
	Logger log = Logger.getLogger(ConsultaExpedientesCodigoAjaxAction.class);
	
	private ExpedienteServicio expedienteServicio;
	
	public ExpedienteServicio getExpedienteServicio() {
		return expedienteServicio;
	}

	public void setExpedienteServicio(ExpedienteServicio expedienteServicio) {
		this.expedienteServicio = expedienteServicio;
	}
	
	private PersonaServicio personaServicio;
	
	public PersonaServicio getPersonaServicio() {
		return personaServicio;
	}

	public void setPersonaServicio(PersonaServicio personaServicio) {
		this.personaServicio = personaServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {		
		
		log.info("############################ Pasa por ConsultaExpedientesCodigo");
		response.setContentType("text/html;charset=UTF-8");
		
		ExpedienteExpandidoForm expedienteExpandidoForm = (ExpedienteExpandidoForm) objetoModelo;		
		ExpedienteExpandido expedienteExpandido = (ExpedienteExpandido) expedienteExpandidoForm.getBean();
		ExpedienteExpandidoResultado expedienteExpandidoResultado = new ExpedienteExpandidoResultado();
		
		expedienteExpandidoResultado.setExpedienteExpandido(expedienteServicio.consultarExpedienteCodigo(expedienteExpandido.getCodExpediente()));
		expedienteExpandidoResultado.getExpedienteExpandido().setInteresado(personaServicio.consultaInteresadoByCodigo(expedienteExpandidoResultado.getExpedienteExpandido().getCodInteresado()));
		expedienteExpandidoResultado.getExpedienteExpandido().setRepresentante(personaServicio.consultaRepresentanteporInteresado(expedienteExpandidoResultado.getExpedienteExpandido().getCodRepresentante()));
		
		List<HistoricoTramitacion> listaHistoricoTramitacion = expedienteServicio.consultarHistoricoTramitacion(expedienteExpandido.getCodExpediente());
		for (HistoricoTramitacion historico : listaHistoricoTramitacion){
			if (historico.getCodHistoricoTramitacion().equals('3')) {
					historico.setCodHistoricoTramitacion("Reobrir");
			} else if (historico.getCodHistoricoTramitacion().equals('4')){
					historico.setCodHistoricoTramitacion("Tancat");
			}
		}
		
		expedienteExpandidoResultado.setListaHistoricoTramitacion(listaHistoricoTramitacion);      
        
        responderPeticionAjax(response, expedienteExpandidoResultado);
		return null;
	}

}
