package es.alten.diputacion.add.web.struts;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


import es.alten.diputacion.add.modelo.ExpedienteExpandido;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.ExpedienteExpandidoForm;
import es.alten.diputacion.add.servicios.ExpedienteServicio;
import es.alten.diputacion.add.servicios.PersonaServicio;

public class CreacionExpedienteAjaxAction extends BaseAction{
	
	Logger log = Logger.getLogger(CreacionExpedienteAjaxAction.class);
	
	private ExpedienteServicio expedienteServicio;
	
	public ExpedienteServicio getExpedienteServicio() {
		return expedienteServicio;
	}

	public void setExpedienteServicio(ExpedienteServicio expedienteServicio) {
		this.expedienteServicio = expedienteServicio;
	}
	
	private PersonaServicio personaServicio;
	
	public PersonaServicio getPersonaServicio() {
		return personaServicio;
	}

	public void setPersonaServicio(PersonaServicio personaServicio) {
		this.personaServicio = personaServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {		
		
		log.info("############################ Pasa por CreacionExpediente");
		response.setContentType("text/html;charset=UTF-8");
		
		ExpedienteExpandidoForm expedienteExpandidoForm = (ExpedienteExpandidoForm) objetoModelo;	
		ExpedienteExpandido expedienteExpandido = (ExpedienteExpandido) expedienteExpandidoForm.getBean();
		
		String resultado = expedienteServicio.validarExpedienteExpandido(expedienteExpandido);
		
		if (resultado == "INCORRECTO") {
			responderPeticionAjax(response, resultado);
			return null;
		}
		
		if (expedienteExpandido.getHistoricoTramitacion().getCodHistoricoTramitacion().equals("3")) {
			expedienteExpandido.getHistoricoTramitacion().setCodEstadoTramitacion("T01");
			expedienteExpandido.setEstadoTramitacion("T01");
		} else if (expedienteExpandido.getHistoricoTramitacion().getCodHistoricoTramitacion().equals("4")){
			expedienteExpandido.getHistoricoTramitacion().setCodEstadoTramitacion("T02");
			expedienteExpandido.setEstadoTramitacion("T02");
		}		

		String codInteresado = personaServicio.crearInteresado(expedienteExpandido.getInteresado());
		
		if (codInteresado == "INCORRECTO") {
			responderPeticionAjax(response, codInteresado);
			return null;
		}
		
		expedienteExpandido.setCodInteresado(codInteresado);
		log.info("############################ Pasa por crearInteresado");
		String codRepresentante = personaServicio.crearRepresentante(expedienteExpandido.getRepresentante());
		
		if (codRepresentante == "INCORRECTO") {
			responderPeticionAjax(response, codRepresentante);
			return null;
		}
		
		expedienteExpandido.setCodRepresentante(codRepresentante);
		log.info("############################ Pasa por crearRepresentante");
		String codExpediente = expedienteServicio.crearExpediente (expedienteExpandido);
		if (codExpediente == "INCORRECTO") {
			responderPeticionAjax(response, codExpediente);
			return null;
		}
		expedienteExpandido.getHistoricoTramitacion().setCodExpediente(codExpediente);
		if (!(expedienteExpandido.getHistoricoTramitacion().getFechaRegistro() == null)){		
			expedienteServicio.crearHistorico(expedienteExpandido.getHistoricoTramitacion());
		}
		String respuesta = "CORRECTO";
		
        responderPeticionAjax(response, respuesta);
		return null;
	}

}
