package es.alten.diputacion.add.web.struts;


import java.io.ByteArrayOutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.DocumentoForm;

import es.alten.diputacion.add.modelo.resultado.DocumentoResultado;
import es.alten.diputacion.add.servicios.DocumentoServicio;

public class GenerarArchivosDocumentosAction extends BaseAction {
	
	private DocumentoServicio documentoServicio;
	
	public DocumentoServicio getDocumentoServicio() {
		return documentoServicio;
	}

	public void setDocumentoServicio(DocumentoServicio documentoServicio) {
		this.documentoServicio = documentoServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		DocumentoForm documentoForm = (DocumentoForm) objetoModelo;
		DocumentoResultado resultado = documentoServicio.validarDocumento(documentoForm);
		resultado.setDocumento(documentoForm);
			
		switch(resultado.getConfirmacion()){
		case CORRECTO: 
				
			String[] elegidos = request.getParameterValues("cheke2");
			byte[] archivos = documentoServicio.obtenerCSVDocumentos(elegidos);
		
				try {				
						
					ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
					outputStream.write(archivos);
					response.setHeader("content-disposition", "attachment;filename=Documentos.csv");
					response.setContentType("text/csv");
					response.setContentLength(outputStream.size());
					ServletOutputStream out = response.getOutputStream();
					outputStream.writeTo(out);
					out.flush();				
				} catch (Exception e) {					
					throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar");
				}		
			
			return mapping.findForward("correcto");
				
		} 
		return mapping.findForward("error");

	}
}