package es.alten.diputacion.add.web.struts;


import java.io.ByteArrayOutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.resultado.AsentamientoResultado;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.DocumentoPendienteForm;
import es.alten.diputacion.add.servicios.AsentamientoServicio;

public class GenerarArchivosDocumentosPendientesAction extends BaseAction {
	
	private AsentamientoServicio asentamientoServicio;
	
	public AsentamientoServicio getAsentamientoServicio() {
		return asentamientoServicio;
	}

	public void setAsentamientoServicio(AsentamientoServicio asentamientoServicio) {
		this.asentamientoServicio = asentamientoServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		DocumentoPendienteForm asentamientoForm = (DocumentoPendienteForm) objetoModelo;
		AsentamientoResultado resultado = asentamientoServicio.validarAsentamiento(asentamientoForm);
		resultado.setAsentamiento(asentamientoForm);
		
		switch(resultado.getConfirmacion()){
		case CORRECTO: 
				
			String[] elegidos = request.getParameterValues("cheke2");
			byte[] archivos = asentamientoServicio.obtenerCSVAsentamientos(elegidos);
			
			try {				
					
				ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
				outputStream.write(archivos);
				response.setHeader("content-disposition", "attachment;filename=Tramites.csv");
				response.setContentType("text/csv");
				response.setContentLength(outputStream.size());
				ServletOutputStream out = response.getOutputStream();
				outputStream.writeTo(out);
				out.flush();				
			} catch (Exception e) {
				throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar");
			}		
			
			return mapping.findForward("correcto");
				
		} 
		return mapping.findForward("error");
		
	}

}