package es.alten.diputacion.add.web.struts;

import java.io.ByteArrayOutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.resultado.ExpedienteResultado;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.ExpedienteForm;
import es.alten.diputacion.add.servicios.ExpedienteServicio;

public class GenerarArchivosExpedienteAction extends BaseAction {
	
	private ExpedienteServicio expedienteServicio;

	public void setExpedienteServicio(ExpedienteServicio expedienteServicio) {
		this.expedienteServicio = expedienteServicio;
	}

	public ExpedienteServicio getExpedienteServicio() {
		return expedienteServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		ExpedienteForm expedienteForm = (ExpedienteForm) objetoModelo;
		ExpedienteResultado resultado = expedienteServicio.validarExpediente(expedienteForm);
		resultado.setExpediente(expedienteForm);
		
		switch(resultado.getConfirmacion()){
		case CORRECTO: 
				
			String[] elegidos = request.getParameterValues("cheke2");
			byte[] archivos = expedienteServicio.obtenerCSVExpedientes(elegidos);
			
			try {				
					
				ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
				outputStream.write(archivos);
				response.setHeader("content-disposition", "attachment;filename=Expedientes.csv");
				response.setContentType("text/csv");
				response.setContentLength(outputStream.size());
				ServletOutputStream out = response.getOutputStream();
				outputStream.writeTo(out);
				out.flush();				
			} catch (Exception e) {
				throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar");
			}		
			
			return mapping.findForward("correcto");
		}
		return mapping.findForward("error");
	}
}