package es.alten.diputacion.add.web.struts;

import java.io.ByteArrayOutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.excepcion.CronosValidacionException;
import es.alten.diputacion.add.modelo.TramiteExpandido;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.TramiteExpandidoForm;
import es.alten.diputacion.add.servicios.TramiteServicio;

public class GenerarArchivosTramitesAction extends BaseAction {
	
	private TramiteServicio tramiteServicio;
	
	public void setTramiteServicio(TramiteServicio tramiteServicio) {
		this.tramiteServicio = tramiteServicio;
	}

	public TramiteServicio getTramiteServicio() {
		return tramiteServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		
		TramiteExpandidoForm tramiteExpandidoForm = (TramiteExpandidoForm) objetoModelo;
		TramiteExpandido tramiteExpandido = (TramiteExpandido) tramiteExpandidoForm.getBean();
				
		String resultado = tramiteServicio.validarTramiteExpandido(tramiteExpandido);
		
		if (resultado == "INCORRECTO") {
			return mapping.findForward("error");
		}

		String[] elegidos = request.getParameterValues("cheke2");
		byte[] archivos = tramiteServicio.obtenerCSVTramites(elegidos);
			
		try {				
					
			ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
			outputStream.write(archivos);
			response.setHeader("content-disposition", "attachment;filename=Tramites.csv");
			response.setContentType("text/csv");
			response.setContentLength(outputStream.size());
			ServletOutputStream out = response.getOutputStream();
			outputStream.writeTo(out);
			out.flush();				
		} catch (Exception e) {
			throw new CronosValidacionException("es.alten.diputacion.add.servicios.generar");
		}		
			
		return mapping.findForward("correcto");

	}
	
}
	
