package es.alten.diputacion.add.web.struts;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.modelo.resultado.LoginResultado;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.modelo.struts.LoginForm;
import es.alten.diputacion.add.servicios.AsentamientoServicio;
import es.alten.diputacion.add.servicios.ExpedienteServicio;
import es.alten.diputacion.add.servicios.LoginServicio;

public class LoginAction extends BaseAction{
	
	
	private Logger log = Logger.getLogger(LoginAction.class);

	public static final String USUARIO ="usuario";
	private LoginServicio loginServicio;
	private AsentamientoServicio asentamientoServicio;
	private ExpedienteServicio expedienteServicio;

	
	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,ActionForm objetoModelo, 
			HttpServletRequest request,HttpServletResponse response) {
		try {
			//return mapping.findForward("ok_login");
	
			LoginForm loginForm = (LoginForm) objetoModelo;
			//LoginResultado resultado = loginServicio.comprobarPasswordYUsuario(loginForm.getCodUsuario(), loginForm.getPassword(), loginForm.getCodEntidad());
			LoginResultado resultado = loginServicio.comprobarPasswordYUsuario(loginForm.getCodUsuario(), loginForm.getPassword());
			switch(resultado.getConfirmacion()){
				case OK: 
					request.getSession().setAttribute(USUARIO,resultado.getUsuario());
					
//					List<UOrganizativa> unidades = asentamientoServicio.obtenerAsentamientosPendientes(resultado.getUsuario());
//					List<Tramite> tramites = expedienteServicio.obtenerCombosExpedientes(resultado.getUsuario());
//					
//					request.getSession().setAttribute("unidades", unidades);
//					request.getSession().setAttribute("tramites",tramites);
//					
//					List<Tipologia> listaTipologia = new ArrayList<Tipologia>();
//					for (Tramite tramite : tramites){
//						Tipologia nuevaTipologia = tramite.getTipologia();
//						if(listaTipologia.indexOf(nuevaTipologia)==-1){
//							listaTipologia.add(nuevaTipologia);
//						}
//					}
//					
//					request.setAttribute("listaTipologia", listaTipologia);
					return mapping.findForward("ok_login");
					
				case KAO_USUARIO:
					request.setAttribute("mensajeError","L'usuari no existeix");
					request.getSession().setAttribute("mensajeError","L'usuari no existeix");
					break;
				case KAO_PASSWOR:
					request.setAttribute("mensajeError","El password s incorrect");
			}
			
			
			
			request.setAttribute("codUsuario",loginForm.getCodUsuario());
			request.setAttribute("password", loginForm.getPassword());
			//request.setAttribute("codEntidad",loginForm.getCodEntidad());
			return mapping.findForward("kao_login");
		}
		catch(Exception e){
			log.error("################  CASCA EL LOGIN ACTION",e);
			return mapping.findForward("kao_login");
		}
	
	}

	public LoginServicio getLoginServicio() {
		return loginServicio;
	}

	public void setLoginServicio(LoginServicio loginServicio) {
		this.loginServicio = loginServicio;
	}

	public void setAsentamientoServicio(AsentamientoServicio asentamientoServicio) {
		this.asentamientoServicio = asentamientoServicio;
	}

	public AsentamientoServicio getAsentamientoServicio() {
		return asentamientoServicio;
	}
	
	public ExpedienteServicio getExpedienteServicio() {
		return expedienteServicio;
	}

	public void setExpedienteServicio(ExpedienteServicio expedienteServicio) {
		this.expedienteServicio = expedienteServicio;
	}
	
}
