package es.alten.diputacion.add.web.struts;

import java.util.ResourceBundle;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.resultado.TramiteConTipologiaGestionableResultado;
import es.alten.diputacion.add.modelo.struts.AltaTramiteForm;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.servicios.AdministracionTramiteServicio;
import es.alten.diputacion.add.util.add.FactoriaResourceBundle;

public class ModificacionTramiteAjaxAction extends BaseAction{
	Logger log = Logger.getLogger(ModificacionTramiteAjaxAction.class);
	private static ResourceBundle rb = FactoriaResourceBundle.getResourceBundle();
	public static final String MENSAJE_ERROR_SUBTIPOLOGIA_NULL="es.alten.diputacion.add.web.struts.ModificacionTramiteAjaxAction.MENSAJE_ERROR_SUBTIPOLOGIA_NULL";
	public static final String MENSAJE_ERROR_DESC_NULL="es.alten.diputacion.add.web.struts.ModificacionTramiteAjaxAction.MENSAJE_ERROR_DESC_NULL";
	private AdministracionTramiteServicio administracionTramiteServicio;
	

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		log.info("############################ MODIFICACION TRAMITE ACTION");
		//try {
		AltaTramiteForm tramiteForm = (AltaTramiteForm)objetoModelo;
		String codTram = tramiteForm.getCodTramite();
		/*try {
			codTram = Long.parseLong(tramiteForm.getCodTramite());
		} catch (NumberFormatException e) {
			e.printStackTrace();
			return null;
		}*/
		Tramite tramite = administracionTramiteServicio.buscarTramitePorCodigoTramite(codTram);
		tramite.setNombreTramite(tramiteForm.getNombreTramite());
		tramite.setDescTramite(tramiteForm.getDescTramite());
		tramite.setCodSubtipologia(tramiteForm.getCodSubtipologia());
		tramite.setTema(tramiteForm.getTema());
		tramite.setFamilia(tramiteForm.getFamilia());
		tramite.setSubfamilia(tramiteForm.getSubfamilia());
		tramite.setArea(tramiteForm.getArea());
		tramite.setAdministracionComponente(tramiteForm.getAdministracionComponente());
		tramite.setNivelProteccion(tramiteForm.getNivelProteccion());
		tramite.setClasificacionArchivo(tramiteForm.getClasificacionArchivo());
		tramite.setPublicidad(tramiteForm.getPublicidad());
		tramite.setEvalSeleccionEliminacion(tramiteForm.getEvalSeleccionEliminacion());
		tramite.setCodEntidad(tramiteForm.getCodEntidad());
		tramite.setCodUOrganizativaDestino(tramiteForm.getCodUOrganizativaDestino());
		//tramite.setFechaRegistro(new Date());
		//tramite.setFechaBaja(null);
		
		//Llamar al servicio para validar el tramite
//		TramiteConTipologiaGestionableResultado tramiteValido = administracionTramiteServicio.validarTramite(tramite);
//		switch(tramiteValido.getConfirmacion()){
//		case SUBTIPOLOGIANULL:
//		case DESCNULL:
//		case CORRECTO:
//		
//		
//		}
		TramiteConTipologiaGestionableResultado tramiteModificado = new TramiteConTipologiaGestionableResultado();
		try {
		
			tramiteModificado = administracionTramiteServicio.modificacionTramite(tramite);	
//			responderPeticionAjax(response, tramiteModificado);
			
		}
		catch(IllegalArgumentException e){
			if(e.getMessage().equals(Tramite.COD_SUBTIPOLOGIA_NULL)){
			
				tramiteModificado.setMensajeDeError(rb.getString(MENSAJE_ERROR_SUBTIPOLOGIA_NULL));
				tramiteModificado.setError(true);
			}
			else if(e.getMessage().equals(Tramite.DESC_TRAMITE_NULL)){
				tramiteModificado.setMensajeDeError(rb.getString(MENSAJE_ERROR_DESC_NULL));
				tramiteModificado.setError(true);
			}
			
		}
		responderPeticionAjax(response, tramiteModificado);
		//}
		//catch(Exception e){
			//log.error(e.getMessage(), e);
			//System.out.println(e.getMessage());
			//e.printStackTrace();
		//}
		return null;
	}

	public void setAdministracionTramiteServicio(
			AdministracionTramiteServicio administracionTramiteServicio) {
		this.administracionTramiteServicio = administracionTramiteServicio;
	}

	public AdministracionTramiteServicio getAdministracionTramiteServicio() {
		return administracionTramiteServicio;
	}

}
