package es.alten.diputacion.add.web.struts;

import java.util.ResourceBundle;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.resultado.UsuarioResultado;
import es.alten.diputacion.add.modelo.struts.AltaUsuarioForm;
import es.alten.diputacion.add.modelo.struts.BaseForm;
import es.alten.diputacion.add.servicios.AdministracionUsuarioServicio;
import es.alten.diputacion.add.util.add.FactoriaResourceBundle;

public class ModificacionUsuarioAjaxAction extends BaseAction{
	Logger log = Logger.getLogger(ModificacionUsuarioAjaxAction.class);
	private static ResourceBundle rb = FactoriaResourceBundle.getResourceBundle();
	public static final String MENSAJE_ERROR_NOMBRE_NULL="es.alten.diputacion.add.web.struts.ModificacionUsuarioAjaxAction.MENSAJE_ERROR_NOMBRE_NULL";
	public static final String MENSAJE_ERROR_PASSWORD_NULL="es.alten.diputacion.add.web.struts.ModificacionUsuarioAjaxAction.MENSAJE_ERROR_PASSWORD_NULL";
	public static final String MENSAJE_ERROR_ROL_NULL="es.alten.diputacion.add.web.struts.ModificacionUsuarioAjaxAction.MENSAJE_ERROR_ROL_NULL";
	private AdministracionUsuarioServicio administracionUsuarioServicio;
	

	public AdministracionUsuarioServicio getAdministracionUsuarioServicio() {
		return administracionUsuarioServicio;
	}

	public void setAdministracionUsuarioServicio(
			AdministracionUsuarioServicio administracionUsuarioServicio) {
		this.administracionUsuarioServicio = administracionUsuarioServicio;
	}

	@Override
	protected void delegarError(BaseForm objetoModelo,
			HttpServletRequest request, HttpServletResponse response) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected ActionForward procesar(ActionMapping mapping,
			ActionForm objetoModelo, HttpServletRequest request,
			HttpServletResponse response) {
		log.info("############################ MODIFICACION USUARIO ACTION");
		//try {
		AltaUsuarioForm usuarioForm = (AltaUsuarioForm)objetoModelo;
		String codUsu = usuarioForm.getCodigo();
		/*try {
			codTram = Long.parseLong(tramiteForm.getCodTramite());
		} catch (NumberFormatException e) {
			e.printStackTrace();
			return null;
		}*/
		Usuario usuario = administracionUsuarioServicio.buscarUsuarioPorCodigoUsuario(codUsu);
		usuario.setNombre(usuarioForm.getNombre());
		usuario.setPassword(usuarioForm.getPassword());
		usuario.setRol(usuarioForm.getRol());
		

		//tramite.setFechaRegistro(new Date());
		//tramite.setFechaBaja(null);
		
		//Llamar al servicio para validar el tramite
//		TramiteConTipologiaGestionableResultado tramiteValido = administracionTramiteServicio.validarTramite(tramite);
//		switch(tramiteValido.getConfirmacion()){
//		case SUBTIPOLOGIANULL:
//		case DESCNULL:
//		case CORRECTO:
//		
//		
//		}
		UsuarioResultado usuarioModificado = new UsuarioResultado();
		
		try {
			usuarioModificado = administracionUsuarioServicio.modificacionUsuario(usuario);
//			responderPeticionAjax(response, tramiteModificado);
			
		}
		catch(IllegalArgumentException e){
			if(e.getMessage().equals(Usuario.NOM_NULL)){
				usuarioModificado.setMensajeDeError(rb.getString(MENSAJE_ERROR_NOMBRE_NULL));
				usuarioModificado.setError(true);
			}
			else if(e.getMessage().equals(Usuario.PASSWORD_NULL)){
				usuarioModificado.setMensajeDeError(rb.getString(MENSAJE_ERROR_PASSWORD_NULL));
				usuarioModificado.setError(true);
			}
			else if(e.getMessage().equals(Usuario.ROL_NULL)){
				usuarioModificado.setMensajeDeError(rb.getString(MENSAJE_ERROR_ROL_NULL));
				usuarioModificado.setError(true);
			}
			
		}
		responderPeticionAjax(response, usuarioModificado);
		//}
		//catch(Exception e){
			//log.error(e.getMessage(), e);
			//System.out.println(e.getMessage());
			//e.printStackTrace();
		//}
		return null;
	}

}
