var regE = new RegExp("^[\\d]*$");


function validarPorcentaje (_importe){


  var importe = _importe;
  
  importe.value = quitarPuntos(importe.value);
  
  var negativo = esNegativo(importe.value);

  
  if(negativo){
	importe.value = importe.value.replace('-', '');
  }
  
  
  //En primer lugar vamos a validar que la cifra introducida es un valor en euros
  if (esEuros(importe)){
    // Le damos formato correcto y colocamos su importe en letra en la pantalla
    var cifra = formatNumber(importe.value);
    importe.value = cifra;
    var letra = covertirNumLetras(quitarPuntos(cifra));
    
    if(negativo){
	importe.value = "-"+importe.value;
    }

  } else {
    alert ("El importe introducido no es una cantidad vlida")
    importe.value = '';
    importe.focus();
  }
}

function validarMoney (_importe){


  var importe = _importe;
  
  importe.value = quitarPuntos(importe.value);
  
  var negativo = esNegativo(importe.value);

  
  if(negativo){
	importe.value = importe.value.replace('-', '');
  }
  
  
  //En primer lugar vamos a validar que la cifra introducida es un valor en euros
  if (esEuros(importe)){
    // Le damos formato correcto y colocamos su importe en letra en la pantalla
    var cifra = formatNumber(importe.value);
    importe.value = cifra;
    var letra = covertirNumLetras(quitarPuntos(cifra));
    
    if(negativo){
	document.getElementById('pagoImporteLetraD').value = "MENOS "+letra;
	importe.value = "-"+importe.value;
	
    }else{
	document.getElementById('pagoImporteLetraD').value = letra;
    }
    
  } else {
    alert ("El importe introducido no es una cantidad vlida")
    importe.value = '';
    document.getElementById('pagoImporteLetraD').value = '';
    importe.focus();
  }
}

function esNegativo(cadena){


  var importe = cadena.replace(',', '')

  
  if (importe<0){
    return true;
  }else{
	return false;
  }
}

function quitarPuntos(cadena){
  while (cadena.indexOf('.')>0){
    cadena = cadena.replace('.', '')
  }
  return cadena;
}

function esEuros(campo) {
  if (esEntero(campo.value)){
    return true;
  } else {
    // Estamos ante un nmero decimal
    var decimal = campo.value.split(",");
    if (decimal.length == 2) {
      // Validamos que ambas partes son un nmero
      if (esEntero(decimal[0]) && esEntero(decimal[1])){
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }
}

function esEntero(valor){
  if (regE.test(valor)){
    return true;
  } else {
    return false;
  }
}

function formatNumber(numero){
  var splitStr = numero.split(',');
  var splitLeft = splitStr[0];
  var decimal = "0."+splitStr[1];
  decimal = parseFloat(decimal).toFixed(2);
  var result = decimal.split('.');
  var splitRight = splitStr.length > 1 ? ',' + result[1] : '';
  var regx = /(\d+)(\d{3})/;
  while (regx.test(splitLeft)) {
    splitLeft = splitLeft.replace(regx, '$1' + '.' + '$2');
  }
  return splitLeft + splitRight;
}

function unformatNumber(num) {
  return num.replace(/([^0-9\.\-])/g,'')*1;
}

// *********************** Funciones para pasar a Letra

// Funcin modulo, regresa el residuo de una divisin 
function mod(dividendo , divisor) { 
  resDiv = dividendo / divisor ;  
  parteEnt = Math.floor(resDiv);            // Obtiene la parte Entera de resDiv 
  parteFrac = resDiv - parteEnt ;      // Obtiene la parte Fraccionaria de la divisin
  modulo = Math.round(parteFrac * divisor);  // Regresa la parte fraccionaria * la divisin (modulo) 
  return modulo; 
} // Fin de funcin mod

// Funcin ObtenerParteEntDiv, regresa la parte entera de una divisin
function ObtenerParteEntDiv(dividendo , divisor) { 
  resDiv = dividendo / divisor ;  
  parteEntDiv = Math.floor(resDiv); 
  return parteEntDiv; 
} // Fin de funcin ObtenerParteEntDiv

// function fraction_part, regresa la parte Fraccionaria de una cantidad
function fraction_part(dividendo , divisor) { 
  resDiv = dividendo / divisor ;  
  f_part = Math.floor(resDiv); 
  return f_part; 
} // Fin de funcin fraction_part


function string_literal_conversion(number) {   
  centenas = ObtenerParteEntDiv(number, 100); 
  number = mod(number, 100); 
  decenas = ObtenerParteEntDiv(number, 10); 
  number = mod(number, 10); 
  unidades = ObtenerParteEntDiv(number, 1); 
  number = mod(number, 1); 
  
  string_hundreds="";
  string_tens="";
  string_units="";
  
  if(centenas == 1){ string_hundreds = "ciento "; } 
  if(centenas == 2){ string_hundreds = "doscientos ";  }
  if(centenas == 3){ string_hundreds = "trescientos ";} 
  if(centenas == 4){ string_hundreds = "cuatrocientos "; } 
  if(centenas == 5){ string_hundreds = "quinientos "; } 
  if(centenas == 6){ string_hundreds = "seiscientos ";  } 
  if(centenas == 7){ string_hundreds = "setecientos "; } 
  if(centenas == 8){ string_hundreds = "ochocientos "; } 
  if(centenas == 9){ string_hundreds = "novecientos "; } 
   
  if(decenas == 1){
    //Special case, depends on units for each conversion
    if(unidades == 1){ string_tens = "once"; } 
    if(unidades == 2){ string_tens = "doce"; }
    if(unidades == 3){ string_tens = "trece"; }
    if(unidades == 4){ string_tens = "catorce"; } 
    if(unidades == 5){ string_tens = "quince"; }
    if(unidades == 6){ string_tens = "dieciseis"; } 
    if(unidades == 7){ string_tens = "diecisiete"; } 
    if(unidades == 8){ string_tens = "dieciocho"; }
    if(unidades == 9){ string_tens = "diecinueve"; }
  } 
   
  if(decenas == 2){ string_tens = "veinti"; }
  if(decenas == 3){ string_tens = "treinta"; }
  if(decenas == 4){ string_tens = "cuarenta"; }
  if(decenas == 5){ string_tens = "cincuenta"; }
  if(decenas == 6){ string_tens = "sesenta"; }
  if(decenas == 7){ string_tens = "setenta"; }
  if(decenas == 8){ string_tens = "ochenta"; }
  if(decenas == 9){ string_tens = "noventa"; }
  
  if (decenas == 1)  { 
    string_units="";  // empties the units check, since it has alredy been handled on the tens switch 
  } 
  else { 
    if(unidades == 1){ string_units = "un"; }
    if(unidades == 2){ string_units = "dos"; }
    if(unidades == 3){ string_units = "tres"; }
    if(unidades == 4){ string_units = "cuatro"; }
    if(unidades == 5){ string_units = "cinco"; }
    if(unidades == 6){ string_units = "seis"; }
    if(unidades == 7){ string_units = "siete"; }
    if(unidades == 8){ string_units = "ocho"; }
    if(unidades == 9){ string_units = "nueve"; }
  } // end if-then-else 
   
  if (centenas == 1 && decenas == 0 && unidades == 0) { 
    string_hundreds = "cien " ; 
  }  
  if (decenas == 1 && unidades ==0) 
  { string_tens = "diez " ; 
  } 
  if (decenas == 2 && unidades ==0) { 
    string_tens = "veinte " ; 
  } 
  if (decenas >=3 && unidades >=1) { 
    string_tens = string_tens+" y "; 
  } 
  final_string = string_hundreds+string_tens+string_units;

  return final_string ; 
} 


function covertirNumLetras(number){
  number1 = number;
  cent = number1.split(',');   
  number = cent[0];
  centimos = cent[1];
   
  if (centimos == 0 || centimos == undefined){
    centimos = "00";
  }
  if (number == 0 || number == "") { // if amount = 0, then forget all about conversions, 
    centenas_final_string =" cero "; // amount is zero (cero). handle it externally, to 
    // function breakdown 
  } 
  else { 
    millions  = ObtenerParteEntDiv(number, 1000000); // first, send the millions to the string 
    number = mod(number, 1000000);           // conversion function 
      
    if (millions != 0){                      
      // This condition handles the plural case 
      if (millions == 1)  {              // if only 1, use 'millon' (million). if 
        descriptor= " millon ";  // > than 1, use 'millones' (millions) as 
      } else  {                           // a descriptor for this triad. 
        descriptor = " millones "; 
      } 
    } else  {    
      descriptor = " ";                 // if 0 million then use no descriptor. 
    } 
    millions_final_string = string_literal_conversion(millions)+descriptor; 
          
    thousands = ObtenerParteEntDiv(number, 1000);  // now, send the thousands to the string 
    number = mod(number, 1000);   
    if (thousands != 1) {                   // This condition eliminates the descriptor 
      thousands_final_string =string_literal_conversion(thousands) + " mil "; 
    } 
    if (thousands == 1) {
      thousands_final_string = " mil "; 
    } if (thousands < 1)  { 
      thousands_final_string = " "; 
    } 
 
    centenas  = number;                     
    centenas_final_string = string_literal_conversion(centenas) ; 
      
  } 
  cad = millions_final_string + thousands_final_string + centenas_final_string; 
   
  /* Convierte la cadena a Maysculas*/
  cad = cad.toUpperCase();  
  
  centimos = string_literal_conversion(centimos)
  
  var importeLetra = cad;
  if (centimos != ''){
    importeLetra += " CON " + centimos.toUpperCase() + " CNTIMOS"
  }
  //alert( "FINAL = " + importeLetra);
  return importeLetra;
}



