package es.alten.cronos.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.simple.ParameterizedRowMapper;
import org.springframework.jdbc.support.lob.DefaultLobHandler;

import es.alten.cronos.add.abstraccion.model.Documento;

public class DiputacionJdbcMapper {

	
	/**
	 * Clase estatica, quese usara para ir mapeando los resultados de los documentos uno a uno
	 */
	public static final class DocumentoMapper implements ParameterizedRowMapper<Documento> {

		// Crea una instancia para manejar los BLOB
		private final DefaultLobHandler lobhandler = new DefaultLobHandler();

		DocumentoMapper () {
			super();
		}

	    // Implementa el metodo de RowMapper
		public Documento mapRow(final ResultSet rs, final int rowNum) throws SQLException {
			Documento documento = new Documento();
			documento.setCodigo(rs.getLong("CODIGO_DOC"));
			documento.setTitulo(rs.getString("TITULO_DOC"));
			documento.setDescripcion(rs.getString("DESCRIPCION_DOC"));
			documento.setContenido(lobhandler.getBlobAsBytes(rs, "CONTENIDO_DOC"));
			documento.setCodigoEntidad(rs.getLong("CODIGO_ENTIDAD"));
			return documento;
	    }
	}

}
