package es.alten.diputacion.add.abstraccion;

import java.util.List;
import es.alten.diputacion.add.modelo.Entidad;

public interface EntidadDao {
	/**
	 * Consulta todas las entidades de la base de datos.
	 * 
	 * @return Una lista de entidades ordenada alfabticamente.
	 */
	List<Entidad>consultarTodasEntidades();
	
	/**
	 * Consulta que devuelve una entidad a partir de si identificador
	 * @param codEntidad identificador nico de una entidad
	 * @return devuelve una entidad que debe existir forzosamente
	 */
	Entidad consultarEntidadPorId(String codEntidad);
}
