package es.alten.diputacion.add.abstraccion;

import java.util.List;
import java.util.Map;

import es.alten.diputacion.add.modelo.Expediente;
import es.alten.diputacion.add.modelo.ExpedienteExpandido;
import es.alten.diputacion.add.util.TipoCondicion;

public interface ExpedienteDao {
	
	public void insertarExpediente(Expediente expediente);
	
	public void updateExpediente(Expediente expediente);
	
	public List<Expediente> consultarTodosExpedientes();
	
	public List<Expediente> consultarTodasExpedientesAbiertos();
	
	public List<Expediente> consultarTodasExpedientesCerrados();
	
	public List<Expediente> consultarTodasExpedientesRechazados();
	
	public List<ExpedienteExpandido> consultaExpedientesPorCriterios(ExpedienteExpandido expedienteExpandido, Map<String, Map<String, TipoCondicion>> listaMetodos);
	
	public List<ExpedienteExpandido> consultaExpedientesPorCriteriosOr(ExpedienteExpandido expedienteExpandido, Map<String, Map<String, TipoCondicion>> listaMetodos);
	
	public Expediente consultaExpedientePorCodigo(String elegido);	
	
	public ExpedienteExpandido consultaExpedienteCodigo(String codExpediente);	
	
	public List<Expediente> consultaExpedientesPorCriteriosAsentamiento(Expediente expediente, Map<String, Map<String, TipoCondicion>> listaMetodos);

	public int updateExpedienteExpandido(ExpedienteExpandido expedienteExpandido);

	public int eliminarExpediente(String elegido);

	public int createExpediente(ExpedienteExpandido expedienteExpandido);
	
}
