package es.alten.diputacion.add.abstraccion;

import java.util.List;

import es.alten.diputacion.add.modelo.Subtipologia;

public interface SubtipologiaDao {
	
	/**
	 * Consulta la subtipologia asociada a un usuario
	 * 
	 * @param codSubtipologia
	 * 
	 * @return Subtipologia asociada.
	 */
	
	public Subtipologia consultaSubtipologiaPorTramite(String codSubtipologia);
	/**
	 * Consulta las subtipologias asociadas a la tipologia gestionable
	 * 
	 * @param codTipologiaGestionable
	 * 
	 * @return Lista de subtipologias
	 */
	public List<Subtipologia> selectSubtipologiaPorTipologiaGestionable(String codTipologiaGestionable);
	
	public List<Subtipologia> getSubtipologiaByCodTipologia(String codTipologia);
}
