package es.alten.diputacion.add.abstraccion;
import java.util.List;
import java.util.Map;

import es.alten.diputacion.add.modelo.Tramite;
import es.alten.diputacion.add.modelo.TramiteExpandido;
import es.alten.diputacion.add.util.TipoCondicion;

public interface TramiteDao {
	
	/**
	 * Consulta todos los tramites asociados a un usuario.
	 * 
	 * @param codUsuario
	 * 
	 * @return Una lista de unidades organizativas ordenada alfabticamente.
	 */
	
	public List<Tramite> consultarTramitesUsuario(String codUsuario);
	
	public List<TramiteExpandido> consultaTramitesPorCriterios(TramiteExpandido tramiteExpandido, Map<String, Map<String, TipoCondicion>> listaMetodos);
	
	public List<TramiteExpandido> consultaTramitesPorCriteriosOr (TramiteExpandido tramiteExpandido, Map<String, Map<String, TipoCondicion>> listaMetodos);

	public List<Tramite> consultarTodasTramites();

	public List<Tramite> consultarTramitesTipologiaGestionable();
	
	public Tramite insertTramite(Tramite tramite);
	
	public Tramite updateTramite(Tramite tramite);

	public void deleteTramite(String idTramite);

	public Tramite buscarTramitePorIdTramite(String id_tramite);
	
	public Tramite consultaTramitePorCodigo(String elegido);	

	public List<Tramite> consultaTramitesByCodigoSubtipologia(String codSubtipologia);	

}
