package es.alten.diputacion.add.abstraccion;
import java.util.ArrayList;
import java.util.List;
import es.alten.diputacion.add.modelo.UOrganizativa;

public interface UOrganizativaDao {
	
	/**
	 * Consulta todas las unidades organizativas asociadas a un usuario.
	 * 
	 * @param codUsuario
	 * 
	 * @return Una lista de unidades organizativas ordenada alfabticamente.
	 */
	List<UOrganizativa> consultarUOrganizativaUsuario(String codUsuario);

	/**
	 * Consulta todas las unidades organizativas asociadas a un usuario y una entidad.
	 * 
	 * @param codUsuario
	 * @param codEntidad
	 * 
	 * @return
	 *
	 **/
	ArrayList<UOrganizativa>consultarTodasUOrganizativas();
	
	/**
	 * Inserta una unidad organizativa
	 * @param unidadOrganica Unidad organica  que se insertar
	 */
	public void insertUnidadOrganica(UOrganizativa unidadOrganica);
	
	/**
	 * Actualiza una unidad organizativa
	 * 
	 * @param uo unidad organizativa a actualizar
	 */
	public void updateUnidadOrganica(UOrganizativa uo);
	/**
	 * metodo que recupera una unidad organizativa por ide
	 * @param codUsuario codigo de usuario
	 * @return Una unidad organizativa
	 */
	
	public UOrganizativa selectUnidadOrganizativaPorCodUOrganizativa(String codUO);

	public List<UOrganizativa> consultarTodasUO();
}
