package es.alten.diputacion.add.abstraccion;
import java.util.List;

import es.alten.diputacion.add.modelo.Usuario;

public interface UsuarioDAO {

	/**
	 * Consulta todos los usuarios de la base de datos.
	 * 
	 * @return Una lista de usuarios
	 */
	
	List<Usuario> consultarTodosUsuarios();
	
	/**
	 * COntar todoas los usuarios
	 * @return
	 */
	int contarTodosUsuarios();

	/**
	 * Consulta en la base de datos un usuario a partir del cdigo de usuario.
	 * 
	 * @param codUsuario Clave primaria del usuario
	 * 
	 * @return Un usuario o null en caso de no existir.
	 */
	/*
	List<Usuario>consultarUsuario(String codUsuario);
	*/
	/**
	 * 
	 * @param codUsuario clave primeria del usuario
	 * @param codigoEntidad clave primeria de la entidad
	 * @return un usuario o null en caso de no existir
	 */
	//Usuario consultarUsuarioPorUsuarioYEntidad(String codUsuario,String codigoEntidad);
	Usuario consultarUsuarioPorUsuarioYEntidad(String codUsuario);
	
	public Usuario insertUsuario(Usuario usuario);
	
	public Usuario updateUsuario(Usuario usuario);
	
	public Usuario buscarUsuarioPorIdUsuario(String id_usuario);

	public void deleteUsuario(String idUsuario);
}
