package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.OperacionDao;
import es.alten.diputacion.add.modelo.Operacion;

public class DaoOperacionImpl implements OperacionDao{
	
	private JdbcTemplate jdbcTemplate;

	public void insertOperacion(Operacion operacion) {
		String sql = "insert into ADD_OPERACION(" +
				"STR_CODOPERACION," +
				"STR_NOMBREOPERACION) " +
				"values(?,?)";
		Object[]parametros = new Object[]{
				operacion.getCodOperacion(),
				operacion.getNombreOperacion()};
		jdbcTemplate.update(sql, parametros);
	}

	public Operacion selectOperacionPorId(String codOperacion) {
		String sql ="select * from ADD_OPERACION where STR_CODOPERACION=?";
		return (Operacion) jdbcTemplate.query(sql, new Object[]{codOperacion}, new RowMapperOperacion());
	}

	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}
	
	private class RowMapperOperacion implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
			Operacion operacion = new Operacion();
			operacion.setCodOperacion(rs.getString("STR_CODOPERACION"));
			operacion.setNombreOperacion(rs.getString("STR_NOMBREOPERACION"));
			return operacion;
		}
	}
}
