package es.alten.diputacion.add.abstraccion.jdbc;
import java.sql.ResultSet;

import java.sql.SQLException;
import java.util.List;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import es.alten.diputacion.add.abstraccion.EntidadDao;

import es.alten.diputacion.add.modelo.Entidad;

public class EntidadDaoImpl implements EntidadDao {
	
	private JdbcTemplate jdbcTemplate;

	@SuppressWarnings("unchecked")
	public List<Entidad> consultarTodasEntidades() {
		return this.jdbcTemplate.query( "select * from ADD_ENTIDAD ORDER BY STR_NOMBREENTIDAD ASC",
			    new RowMapperEntidad());
	}

	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	public Entidad consultarEntidadPorId(String codEntidad) {
		String sql = "select * from ADD_ENTIDAD where STR_CODENTIDAD=?";
		return (Entidad) this.jdbcTemplate.queryForObject(sql, new Object[]{codEntidad}, new RowMapperEntidad());
	}
	
	private class RowMapperEntidad implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
			Entidad entidad = new Entidad();
            entidad.setCodEntidad(rs.getString("STR_CODENTIDAD"));
            entidad.setNombreEntidad(rs.getString("STR_NOMBREENTIDAD"));
            return entidad;
		}
	}
}
