package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.ObjetoDigitalDao;
import es.alten.diputacion.add.modelo.ObjetoDigital;

public class ObjetoDigitalDaoImpl implements ObjetoDigitalDao{
	
	private JdbcTemplate jdbcTemplate;
	
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	private class RowMapperObjetoDigital implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
			ObjetoDigital objetoDigital = new ObjetoDigital();
			objetoDigital.setCodObjetoDigital(rs.getString("STR_CODOBJETODIGITAL"));
			objetoDigital.setNumOrdenArchivo(rs.getInt("INT_NUMORDENARCHIVO"));
			objetoDigital.setCodDocumento(rs.getString("STR_CODDOCUMENTO"));
			objetoDigital.setNaturaleza(rs.getString("STR_NATURALEZA"));
			objetoDigital.setNombreFichero(rs.getString("STR_NOMBREFICHERO"));
			objetoDigital.setRutaFichero(rs.getString("STR_RUTAFICHERO"));
			objetoDigital.setSoftProductor(rs.getString("STR_SOFTPRODUCTOR"));
			objetoDigital.setVersionSoftProductor(rs.getString("STR_VERSIONSOFTPRODUCTOR"));
			objetoDigital.setVersionDocumento(rs.getString("STR_VERSIONDOCUMENTO"));
			objetoDigital.setFechaCreacionFichero(rs.getDate("FEC_FECHACREACIONFICHERO"));
			objetoDigital.setFechaModificacionFichero(rs.getDate("FEC_FECHAMODIFICACIONFICHERO"));
			objetoDigital.setFormatoFichero(rs.getString("STR_FORMATOFICHERO"));
			objetoDigital.setImagenAncho(rs.getInt("INT_IMAGENANCHO"));
			objetoDigital.setImagenAltura(rs.getInt("INT_IMAGENALTURA"));
			objetoDigital.setImagenPixelsHorizontal(rs.getInt("INT_IMAGENPIXELSHORIZONTAL"));
			objetoDigital.setImagenPixelsVertical(rs.getInt("INT_IMAGENPIXELSVERTICAL"));
			objetoDigital.setImagenProfundidadBits(rs.getInt("INT_IMAGENPROFUNDIDADBITS"));
			objetoDigital.setNumCuadros(rs.getInt("INT_NUMCUADROS"));
			objetoDigital.setSoftOcr(rs.getString("STR_SOFTOCR"));
			objetoDigital.setPdfa(rs.getString("IND_PDFA"));
			return objetoDigital;
		}
	}

	@SuppressWarnings("unchecked")
	public List<ObjetoDigital> consultarObjetosDigitalesPorCodigoDocumento(
			String codDocumento) {
		return this.jdbcTemplate.query("SELECT * FROM ADD_OBJETODIGITAL " + 
				"WHERE STR_CODDOCUMENTO = ?", new Object []{codDocumento},new RowMapperObjetoDigital());
	}

}
