package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.SubExpedienteDao;
import es.alten.diputacion.add.modelo.SubExpediente;
import es.alten.diputacion.add.util.SecuenciadorProvicional;

public class SubExpedienteDaoImpl implements SubExpedienteDao{

	private JdbcTemplate jdbcTemplate;
	
	private class RowMapperSubExpediente implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
			SubExpediente subExpediente = new SubExpediente();
			subExpediente.setCodSubExpediente(rs.getString("COD_SUBEXPEDIENTE"));
			subExpediente.setNombreCarpeta(rs.getString("STR_NOMBRECARPETA"));
			subExpediente.setTituloSubExpediente(rs.getString("STR_TITULOSUBEXPEDIENTE"));
			subExpediente.setTipoSubExpediente(rs.getString("STR_TIPOSUBEXPEDIENTE"));
			subExpediente.setDescSubExpediente(rs.getString("STR_DESCSUBEXPEDIENTE"));
			subExpediente.setPublicidad(rs.getString("IND_PUBLICIDAD"));
			subExpediente.setCodExpediente(rs.getString("STR_CODEXPEDIENTE"));
			return subExpediente;
		}
	}
	
	public SubExpediente insertSubExpediente(SubExpediente subExpediente) {
		//int codigoSubExpediente = this.jdbcTemplate.queryForInt("SELECT MAX(COD_SUBEXPEDIENTE) FROM ADD_SUBEXPEDIENTE");
		//codigoSubExpediente = codigoSubExpediente+1;
		//String codSubExpediente = new Integer(codigoSubExpediente).toString();
		int codigoSubExpediente = SecuenciadorProvicional.getSecuencia();
		String codSubExpediente = new Integer(codigoSubExpediente).toString();
		String sql ="insert into ADD_SUBEXPEDIENTE(" +
		"COD_SUBEXPEDIENTE," +
		"STR_NOMBRECARPETA," +
		"STR_TITULOSUBEXPEDIENTE," +
		"STR_TIPOSUBEXPEDIENTE," +
		"STR_DESCSUBEXPEDIENTE," +
		"IND_PUBLICIDAD," +
		"STR_CODEXPEDIENTE) values(?,?,?,?,?,?,?)" ;
		Object[] parametros = new Object[]{
				codSubExpediente,
				subExpediente.getNombreCarpeta(),
				subExpediente.getTituloSubExpediente(),
				subExpediente.getTipoSubExpediente(),
				subExpediente.getDescSubExpediente(),
				subExpediente.getPublicidad(),
				subExpediente.getCodExpediente()};
		jdbcTemplate.update(sql,parametros);
		return buscarSubExpedientePorCodSubExpediente(codSubExpediente);
		
	}
	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}
	public SubExpediente buscarSubExpedientePorCodSubExpediente(
			String codSubExpediente) {
		return (SubExpediente) this.jdbcTemplate.queryForObject("SELECT * FROM ADD_SUBEXPEDIENTE " + 
				" WHERE COD_SUBEXPEDIENTE = ?", new Object[] { codSubExpediente }, new RowMapperSubExpediente());
	}

}
