package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;

import java.sql.SQLException;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.SubtipologiaDao;

import es.alten.diputacion.add.modelo.Subtipologia;

public class SubtipologiaDaoImpl implements SubtipologiaDao{
	
	Logger log = Logger.getLogger(SubtipologiaDaoImpl.class);
	private JdbcTemplate jdbcTemplate;	
	
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	public Subtipologia consultaSubtipologiaPorTramite(String codSubtipologia) {
		try {
			StringBuffer sbQuery = new StringBuffer();
			sbQuery.append("SELECT * FROM ADD_SUBTIPOLOGIA WHERE STR_CODSUBTIPOLOGIA = ?");

			return (Subtipologia) this.jdbcTemplate.queryForObject(sbQuery.toString(), new Object[] { codSubtipologia }, 
					new RowMapperSubtipologia());
		} catch (EmptyResultDataAccessException e) {
			return null;
		}
	}
	
	private class RowMapperSubtipologia implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
			Subtipologia subtipologia = new Subtipologia();
	    	subtipologia.setCodSubtipologia(rs.getString("STR_CODSUBTIPOLOGIA"));
	    	subtipologia.setNombreSubtipologia(rs.getString("STR_NOMBRESUBTIPOLOGIA"));
	    	subtipologia.setDescSubtipologia(rs.getString("STR_DESCSUBTIPOLOGIA"));
	    	subtipologia.setCodTipologia(rs.getString("STR_CODTIPOLOGIA"));
	        return subtipologia;
		}
	}

	@SuppressWarnings("unchecked")
	public List<Subtipologia> selectSubtipologiaPorTipologiaGestionable(String codTipologiaGestionable) {
		return this.jdbcTemplate.query("SELECT * FROM ADD_SUBTIPOLOGIA WHERE STR_CODTIPOLOGIA = '" + codTipologiaGestionable + 
				"'" , new RowMapperSubtipologia());	
	}
	
	@SuppressWarnings("unchecked")
	public List<Subtipologia> getSubtipologiaByCodTipologia(String codTipologia) {

		return this.jdbcTemplate.query(
					"SELECT * FROM ADD_SUBTIPOLOGIA WHERE STR_CODSUBTIPOLOGIA = ?", 
					new Object[] { codTipologia }, 
					new RowMapperSubtipologia() );

	}

}
