package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.apache.log4j.Logger;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.TipologiaDao;
import es.alten.diputacion.add.modelo.Tipologia;

public class TipologiaDaoImpl implements TipologiaDao{
	
	Logger log = Logger.getLogger(TipologiaDaoImpl.class);
	
	private JdbcTemplate jdbcTemplate;	
	
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}
	
	public Tipologia consultaTipologiaPorSubtipologia(String codTipologia) {
		try {
			StringBuffer sbQuery = new StringBuffer();
			sbQuery.append("SELECT * FROM ADD_TIPOLOGIA WHERE STR_CODTIPOLOGIA = ?");

			return (Tipologia) this.jdbcTemplate.queryForObject(sbQuery.toString(), 
					new Object[] { codTipologia }, new RowMapperTipologia());
		} catch (EmptyResultDataAccessException e) {
			return null;
		}
	}
	
	private class RowMapperTipologia implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
	    	Tipologia tipologia = new Tipologia();
	    	tipologia.setCodTipologia(rs.getString("STR_CODTIPOLOGIA"));
	    	tipologia.setNombreTipologia(rs.getString("STR_NOMBRETIPOLOGIA"));
	    	tipologia.setDescTipologia(rs.getString("STR_DESCCATEGORIA"));
	    	tipologia.setGestionable(rs.getString("STR_GESTIONABLE"));
	        return tipologia;
		}
	}
	
	public Tipologia selectTipologiaGestionable() {
		StringBuffer sbQuery = new StringBuffer();
		sbQuery.append("SELECT * FROM ADD_TIPOLOGIA WHERE STR_GESTIONABLE = 'S'");

		return (Tipologia) this.jdbcTemplate.queryForObject(sbQuery.toString(), new RowMapperTipologia());
	}

}
