package es.alten.diputacion.add.abstraccion.jdbc;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import es.alten.diputacion.add.abstraccion.UOrganizativaDao;
import es.alten.diputacion.add.modelo.UOrganizativa;

public class UOrganizativaDaoImpl implements UOrganizativaDao{
	
	Logger log = Logger.getLogger(UOrganizativaDaoImpl.class);
	private JdbcTemplate jdbcTemplate;
	
	@SuppressWarnings("unchecked")
	public List<UOrganizativa> consultarUOrganizativaUsuario(String codUsuario) {
		return this.jdbcTemplate.query("select * from ADD_USUARIO_UORGANIZATIVA, ADD_UORGANIZATIVA " +
				"WHERE ADD_USUARIO_UORGANIZATIVA.STR_CODUSUARIO = '" + codUsuario 
				+ "'AND ADD_USUARIO_UORGANIZATIVA.STR_CODUORGANIZATIVA=ADD_UORGANIZATIVA.STR_CODUORGANIZATIVA",
				new RowMapperUOrganizativaUsuario());
	}
	
    @SuppressWarnings("unchecked")
	public List<UOrganizativa> consultarTodasUO(){
    	return this.jdbcTemplate.query("select * from ADD_UORGANIZATIVA",new RowMapperUOrganizativaUsuario());
    }
    
	@SuppressWarnings("unchecked")
	public ArrayList<UOrganizativa> consultarTodasUOrganizativas() {
		try {
			return new ArrayList(this.jdbcTemplate.query( "select * from ADD_UORGANIZATIVA",new RowMapperUOrganizativaUsuario()));
		}
		catch(EmptyResultDataAccessException e){
			return new ArrayList<UOrganizativa>();
		}
	}
	
	private class RowMapperUOrganizativaUsuario implements RowMapper {
		 public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
        	UOrganizativa unidad = new UOrganizativa();
            unidad.setCodUOrganizativa(rs.getString("STR_CODUORGANIZATIVA"));
            unidad.setNombreUOrganizativa(rs.getString("STR_NOMBREUORGANIZATIVA"));
            unidad.setDescUOrganizativa(rs.getString("STR_DESCUORGANIZATIVA"));
            unidad.setCodEntidad(rs.getString("STR_CODENTIDAD"));
            unidad.setFechaActivacion(rs.getDate("FEC_FECHAACTIVACION"));
            unidad.setFechaBaja(rs.getDate("FEC_FECHABAJA"));
            unidad.setFechaRegistro(rs.getDate("FEC_FECHAREGISTRO"));
            unidad.setEstado(rs.getString("STR_ESTADO"));
            return unidad;
        }
	}
	
	public void insertUnidadOrganica(UOrganizativa uo){
			String sql="insert into ADD_UORGANIZATIVA (STR_CODUORGANIZATIVA,STR_NOMBREUORGANIZATIVA,STR_DESCUORGANIZATIVA," +
					"STR_CODENTIDAD,FEC_FECHAREGISTRO,FEC_FECHAACTIVACION,FEC_FECHABAJA,STR_ESTADO)values(?,?,?,?,?,?,?,?)";
			Object[] parametros = new Object[]{
					uo.getCodUOrganizativa(),
					uo.getNombreUOrganizativa(),
					uo.getDescUOrganizativa(),
					uo.getCodEntidad(),
					uo.getFechaRegistro(),
					uo.getFechaActivacion(),
					uo.getFechaBaja(),
					uo.getEstado()};
			jdbcTemplate.update(sql,parametros);
	}
	
	public void updateUnidadOrganica(UOrganizativa uo){
		String sql="update ADD_UORGANIZATIVA set " +
				"STR_NOMBREUORGANIZATIVA=?," +
				"STR_DESCUORGANIZATIVA=?," +
				"STR_CODENTIDAD=?," +
				"FEC_FECHAREGISTRO=?," +
				"FEC_FECHAACTIVACION=?," +
				"FEC_FECHABAJA=?," +
				"STR_ESTADO=?" +
				" where STR_CODUORGANIZATIVA=?";
		Object[] parametros = new Object[]{uo.getNombreUOrganizativa(),
				uo.getDescUOrganizativa(),
				uo.getCodEntidad(),
				uo.getFechaRegistro(),
				uo.getFechaActivacion(),
				uo.getFechaBaja(),
				uo.getEstado(),
				uo.getCodUOrganizativa()};
		jdbcTemplate.update(sql, parametros);
	}
	
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	public UOrganizativa selectUnidadOrganizativaPorCodUOrganizativa(String codUO) {
		String sql ="select * from ADD_UORGANIZATIVA where STR_CODUORGANIZATIVA=?";
		Object[] parametro = new Object[]{codUO};
		return (UOrganizativa) jdbcTemplate.queryForObject(sql, parametro, new RowMapperUOrganizativaUsuario());
	}
}
