package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.UsuarioTramiteDao;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.UsuarioTramite;

public class UsuarioTramiteDaoImpl implements UsuarioTramiteDao {
	Logger log = Logger.getLogger( UsuarioTramiteDaoImpl.class);
	private JdbcTemplate jdbcTemplate;

	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}

	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	public int insertCodUsuarioCodTramite(UsuarioTramite usrTramite) {
		try {
			String sql = "insert into ADD_USUARIO_TRAMITE("
					+ "STR_CODTRAMITE," + "STR_CODUSUARIO) values(?,?)";
			Object[] parametros = new Object[] { 
					usrTramite.getCodTramite(), usrTramite.getCodUsuario(),};
			
			 return jdbcTemplate.update(sql,parametros);
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return -1;
		}
	}
	
	private class RowMapperUsuario implements RowMapper {
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
	        	Usuario user = new Usuario();
	            user.setCodigo(rs.getString("STR_CODUSUARIO"));
	            user.setRol(rs.getString("IND_ROLUSUARIO"));
	            user.setNombre(rs.getString("STR_NOMBREUSUARIO"));
	            user.setPassword(rs.getString("STR_PASSWORD"));
	            user.setFechaAlta(rs.getDate("FEC_FECHAALTAUSUARIO"));
	            user.setFechaBaja(rs.getDate("FEC_FECHABAJAUSUARIO"));
	            return user;
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Usuario> selectCodUsuarioValido(String codTramite) {
		return this.jdbcTemplate.query("select * from add_usuario where add_usuario.str_codusuario NOT IN "
		+ "(select add_usuario_tramite.str_codusuario from add_usuario_tramite where str_codtramite=?)",
		new Object[]  {codTramite},new RowMapperUsuario());
				
	}

	@SuppressWarnings("unchecked")
	public List<Usuario> selectCodUsuarioNoValido(String codTramite) {
		return this.jdbcTemplate.query("select * from add_usuario where add_usuario.str_codusuario IN"
				+"(select add_usuario_tramite.str_codusuario from add_usuario_tramite where str_codtramite=?)",
				new Object[] {codTramite},new RowMapperUsuario());
	}

	public int deleteCodUsuarioCodTramite(UsuarioTramite usrTramite) {
		try {
			return this.jdbcTemplate.update("DELETE FROM ADD_USUARIO_TRAMITE WHERE STR_CODTRAMITE = ?",
					new Object[] {usrTramite.getCodTramite()});
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return -1;
		}
	}
}
