package es.alten.diputacion.add.abstraccion.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;

import es.alten.diputacion.add.abstraccion.UsuarioUODao;
import es.alten.diputacion.add.modelo.Usuario;
import es.alten.diputacion.add.modelo.UsuarioUO;

public class UsuarioUODaoImpl implements UsuarioUODao {
	
	Logger log = Logger.getLogger(UOrganizativaDaoImpl.class);
	private JdbcTemplate jdbcTemplate;
	
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}
	
	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}

	public int insertCodUsuarioCodUO(UsuarioUO usrUO) {
		try {
			String sql ="insert into ADD_USUARIO_UORGANIZATIVA(" +
			"STR_CODUORGANIZATIVA," +
			"STR_CODUSUARIO) values(?,?)" ;
			Object[] parametros = new Object[]{
			usrUO.getCodUO(),
			usrUO.getCodUsuario()};
			return jdbcTemplate.update(sql,parametros);
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return -1;
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Usuario> selectCodUsuarioValido(String codUO) {
		return this.jdbcTemplate.query("select * from add_usuario where add_usuario.str_codusuario NOT IN "+
		"(select add_usuario_UOrganizativa.str_codusuario from add_Usuario_UOrganizativa where str_codUorganizativa=?)",
		new Object[]{codUO},
		new RowMapperUsuario());
				
			
	}

	@SuppressWarnings("unchecked")
	public List<Usuario> selectCodUsuarioNoValido(String codUO) {
		return this.jdbcTemplate.query("select * from add_usuario where add_usuario.str_codusuario IN "+
		"(select add_usuario_UOrganizativa.str_codusuario from add_Usuario_UOrganizativa where str_codUorganizativa=?)",
		new Object[]{codUO},
		new RowMapperUsuario());
	}
	
	private class RowMapperUsuario implements RowMapper{
		public Object mapRow(ResultSet rs, int rowNum) throws SQLException {
	        	Usuario user = new Usuario();
	            user.setCodigo(rs.getString("STR_CODUSUARIO"));
	            user.setRol(rs.getString("IND_ROLUSUARIO"));
	            user.setNombre(rs.getString("STR_NOMBREUSUARIO"));
	            user.setPassword(rs.getString("STR_PASSWORD"));
	            user.setFechaAlta(rs.getDate("FEC_FECHAALTAUSUARIO"));
	            user.setFechaBaja(rs.getDate("FEC_FECHABAJAUSUARIO"));
	            return user;
		}
	}

	public int deleteCodUsuarioCodUO(UsuarioUO usrUO) {
		try {
			String sql ="DELETE FROM ADD_USUARIO_UORGANIZATIVA"+
			" WHERE STR_CODUORGANIZATIVA=?";
			Object[] parametros= new Object[]{usrUO.getCodUO()} ;
			return jdbcTemplate.update(sql,parametros);
		} catch (DataAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return -1;
		}
	}
}
