/**
 * 
 */
package es.alten.diputacion.add.excepcion;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * Base de todas las excepciones creadas para hojas verdes.
 * 
 * @author masanchez
 * 
 */
public class CronosBaseException extends CronosRuntimeException {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Map<String, Object> errores;

	public CronosBaseException() {
		super();
		errores = new LinkedHashMap<String, Object>();
	}

	public CronosBaseException(String mensaje) {
		super(mensaje);
		errores = new LinkedHashMap<String, Object>();
	}

	@Override
	public void addError(String error) {
		errores.put(error, (String[]) null);
	}

	@Override
	public void addError(String error, Object object) {
		errores.put(error, object);
	}

	@Override
	public Map<String, Object> getErrores() {
		return errores;
	}

	@Override
	public void lanzarErrores() {
		if (!errores.isEmpty()) {
			throw this;
		}
	}

}
