/**
 * 
 */
package es.alten.diputacion.add.excepcion;

import java.util.Map;

/**
 * Excepcin runtime de hojas verdes.
 * 
 * @author masanchez
 * 
 */
@SuppressWarnings("serial")
public abstract class CronosRuntimeException extends RuntimeException {

	public CronosRuntimeException() {
		super();
	}

	public CronosRuntimeException(String mensaje) {
		super(mensaje);
	}

	/**
	 * Devuelve todos los errores producidos durante las validaciones.
	 * 
	 * @return
	 */
	public abstract Map<String, Object> getErrores();

	/**
	 * Aade un error y su parmetros.
	 */
	public abstract void addError(String error, Object object);

	/**
	 * Aade un error producidos durante las validaciones.
	 */
	public abstract void addError(String error);

	/**
	 * Lanza la expection adecuada.
	 */
	public abstract void lanzarErrores();

}
