package es.alten.diputacion.add.modelo;

import java.util.Date;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;

/**
 * DTO que representa los documentos pendientes
 * @author Alberto
 *
 */

@SuppressWarnings("serial")
public class Asentamiento implements ObjetoDominio {
	
	private String codAsentamiento;
	private String asunto;
	private Date fechaRegistro;
	private Date fechaDocumento;
	private Date fechaPresentacion;
	private Date fechaAceptacion;
	private Date fechaRechazo;
	private String tipoAsentamiento;
	private String viaPresentacion;
	private String soporteFisico;
	private String urgente;
	private String faltaDocEscaner;
	private String observaciones;
	private String codUOrganizativa;
	private String codEstado;
	private String codExpediente;
	private String codInteresado;
	private String motivoRechazo;
	private String codTramite;
	
	public String getCodAsentamiento() {
		return codAsentamiento;
	}
	public void setCodAsentamiento(String codAsentamiento) {
		this.codAsentamiento = codAsentamiento;
	}
	public String getAsunto() {
		return asunto;
	}
	public void setAsunto(String asunto) {
		this.asunto = asunto;
	}
	public Date getFechaRegistro() {
		return fechaRegistro;
	}
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}
	public Date getFechaDocumento() {
		return fechaDocumento;
	}
	public void setFechaDocumento(Date fechaDocumento) {
		this.fechaDocumento = fechaDocumento;
	}
	public Date getFechaPresentacion() {
		return fechaPresentacion;
	}
	public void setFechaPresentacion(Date fechaPresentacion) {
		this.fechaPresentacion = fechaPresentacion;
	}
	public Date getFechaAceptacion() {
		return fechaAceptacion;
	}
	public void setFechaAceptacion(Date fechaAceptacion) {
		this.fechaAceptacion = fechaAceptacion;
	}
	public Date getFechaRechazo() {
		return fechaRechazo;
	}
	public void setFechaRechazo(Date fechaRechazo) {
		this.fechaRechazo = fechaRechazo;
	}
	public String getTipoAsentamiento() {
		return tipoAsentamiento;
	}
	public void setTipoAsentamiento(String tipoAsentamiento) {
		this.tipoAsentamiento = tipoAsentamiento;
	}
	public String getViaPresentacion() {
		return viaPresentacion;
	}
	public void setViaPresentacion(String viaPresentacion) {
		this.viaPresentacion = viaPresentacion;
	}
	public String getSoporteFisico() {
		return soporteFisico;
	}
	public void setSoporteFisico(String soporteFisico) {
		this.soporteFisico = soporteFisico;
	}
	public String getUrgente() {
		return urgente;
	}
	public void setUrgente(String urgente) {
		this.urgente = urgente;
	}
	public String getFaltaDocEscaner() {
		return faltaDocEscaner;
	}
	public void setFaltaDocEscaner(String faltaDocEscaner) {
		this.faltaDocEscaner = faltaDocEscaner;
	}
	public String getObservaciones() {
		return observaciones;
	}
	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}
	public String getCodUOrganizativa() {
		return codUOrganizativa;
	}
	public void setCodUOrganizativa(String codUOrganizativa) {
		this.codUOrganizativa = codUOrganizativa;
	}
	public String getCodEstado() {
		return codEstado;
	}
	public void setCodEstado(String codEstado) {
		this.codEstado = codEstado;
	}
	public String getCodExpediente() {
		return codExpediente;
	}
	public void setCodExpediente(String codExpediente) {
		this.codExpediente = codExpediente;
	}
	public String getCodInteresado() {
		return codInteresado;
	}
	public void setCodInteresado(String codInteresado) {
		this.codInteresado = codInteresado;
	}
	public String getMotivoRechazo() {
		return motivoRechazo;
	}
	public void setMotivoRechazo(String motivoRechazo) {
		this.motivoRechazo = motivoRechazo;
	}
	public void setCodTramite(String codTramite) {
		this.codTramite = codTramite;
	}
	public String getCodTramite() {
		return codTramite;
	}
	private Date fechaRegistroDocPte;
	private Date fechaAceptacionDocPte;
	private Date fechaRechazoDocPte;

	public String getCodDocumentoPendiente() {
		return codAsentamiento;
	}
	public void setCodDocumentoPendiente(String codDocumentoPendiente) {
		this.codAsentamiento = codDocumentoPendiente;
	}
	public Date getFechaRegistroDocPte() {
		return fechaRegistroDocPte;
	}
	public void setFechaRegistroDocPte(Date fechaRegistroDocPte) {
		this.fechaRegistroDocPte = fechaRegistroDocPte;
	}
	public Date getFechaAceptacionDocPte() {
		return fechaAceptacionDocPte;
	}
	public void setFechaAceptacionDocPte(Date fechaAceptacionDocPte) {
		this.fechaAceptacionDocPte = fechaAceptacionDocPte;
	}
	public Date getFechaRechazoDocPte() {
		return fechaRechazoDocPte;
	}
	public void setFechaRechazoDocPte(Date fechaRechazoDocPte) {
		this.fechaRechazoDocPte = fechaRechazoDocPte;
	}


}
