package es.alten.diputacion.add.modelo;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;

@SuppressWarnings("serial")
public class Documento implements ObjetoDominio {
	
	private String codDocumento;
	private String codExpediente;
	private String soporte;
	private String nivelDescripcion;
	private String tituloDocumento;
	private String productor;
	private String unidadProductora;	
	private Date fechaCaducidad;
	private Date fechaDocumento;
	private String codInteresado;
	private String codAsentamiento;
	private String visible;
	private Persona persona;
	private List<ObjetoDigital> objetosDigitales;
	private List testimonios;
	
	
	public Documento() {
		super();
		this.persona = new Persona();
		this.objetosDigitales = new ArrayList<ObjetoDigital>();
		this.testimonios = new ArrayList();
	}

	public List<ObjetoDigital> getObjetosDigitales() {
		return objetosDigitales;
	}

	public void setObjetosDigitales(List<ObjetoDigital> objetosDigitales) {
		this.objetosDigitales = objetosDigitales;
	}

	public void addObjetoDigital(ObjetoDigital objetoDigital) {
		this.objetosDigitales.add(objetoDigital);
	}
	
	public List getTestimonios() {
		return testimonios;
	}

	public void setTestimonios(List testimonios) {
		this.testimonios = testimonios;
	}

	public String getCodDocumento() {
		return codDocumento;
	}
	
	public void setCodDocumento(String codDocumento) {
		this.codDocumento = codDocumento;
	}
	
	public String getCodExpediente() {
		return codExpediente;
	}
	
	public void setCodExpediente(String codExpediente) {
		this.codExpediente = codExpediente;
	}
	
	public String getSoporte() {
		return soporte;
	}
	
	public void setSoporte(String soporte) {
		this.soporte = soporte;
	}
	
	public String getNivelDescripcion() {
		return nivelDescripcion;
	}
	
	public void setNivelDescripcion(String nivelDescripcion) {
		this.nivelDescripcion = nivelDescripcion;
	}
	
	public void setTituloDocumento(String tituloDocumento) {
		this.tituloDocumento = tituloDocumento;
	}

	public String getTituloDocumento() {
		return tituloDocumento;
	}

	public String getProductor() {
		return productor;
	}
	
	public void setProductor(String productor) {
		this.productor = productor;
	}
	
	public String getUnidadProductora() {
		return unidadProductora;
	}
	
	public void setUnidadProductora(String unidadProductora) {
		this.unidadProductora = unidadProductora;
	}
	
	public Date getFechaCaducidad() {
		return fechaCaducidad;
	}
	
	public void setFechaCaducidad(Date fechaCaducidad) {
		this.fechaCaducidad = fechaCaducidad;
	}
	
	public Date getFechaDocumento() {
		return fechaDocumento;
	}
	
	public void setFechaDocumento(Date fechaDocumento) {
		this.fechaDocumento = fechaDocumento;
	}
	
	public String getCodInteresado() {
		return codInteresado;
	}
	
	public void setCodInteresado(String codInteresado) {
		this.codInteresado = codInteresado;
	}
	
	public String getCodAsentamiento() {
		return codAsentamiento;
	}
	
	public void setCodAsentamiento(String codAsentamiento) {
		this.codAsentamiento = codAsentamiento;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}

	public Persona getPersona() {
		return persona;
	}

	public void setVisible(String visible) {
		this.visible = visible;
	}

	public String getVisible() {
		return visible;
	}
	
}
