/**
 * 
 */
package es.alten.diputacion.add.modelo;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;
import es.alten.diputacion.add.excepcion.CronosValidacionException;

/**
 * DTO que representa los roles que pueden tener los usuarios del sistema.
 * 
 * @author Pedro
 * 
 */
@SuppressWarnings("serial")
public class Rol implements ObjetoDominio{

	private long rol;
	private String descripcion;

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	/**
	 * Validacin del rol de un usuario. El rol de entrada debe validarse con el
	 * rol que tiene asignado el usuario.
	 * 
	 * @param rol
	 * 
	 */
	public void validarRol(Roles rol) {
		long rolBuscado = rol.getCodigo();
		if (this.rol != rolBuscado) {
			throw new CronosValidacionException(
					"es.alten.cronos.injuve.geexpediente.modelo.rol.rol");
		}
	}

	/**
	 * Se obtiene el nmero de rol.
	 * 
	 * @return Nmero de rol
	 */
	public long getNumeroROL() {
		return rol;
	}

	/**
	 * Se establece el nmero de rol.
	 * 
	 * @param numeroROL
	 */
	public void setNumeroROL(long numeroROL) {
		this.rol = numeroROL;
	}

}
