package es.alten.diputacion.add.modelo;

import java.util.Date;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;
import es.alten.diputacion.add.aspectos.ValidableRequest;


@SuppressWarnings("serial")
public class Tramite implements ObjetoDominio, ValidableRequest {
	public static final String COD_SUBTIPOLOGIA_NULL="es.alten.diputacion.add.modelo.Tramite.COD_SUBTIPOLOGIA_NULL";
	public static final String DESC_TRAMITE_NULL="es.alten.diputacion.add.modelo.Tramite.DESC_TRAMITE_NULL";
	private String codigoTramite;
	private String nombreTramite;
	private String descTramite;
	private String codSubtipologia;
	private String tema;
	private String familia;
	private String subfamilia;
	private String area;
	private String administracionComponente;
	private String nivelProteccion;
	private String clasificacionArchivo;
	private String publicidad;
	private String evalSeleccionEliminacion;
	private String codEntidad;
	private String codUOrganizativaDestino;
	private Date fechaBaja;
	private Date fechaRegistro;
	private String eliminado;
	
	//Ignorar
	private Subtipologia subtipologia;
	private Tipologia tipologia;
	
	public String getCodigoTramite() {
		return codigoTramite;
	}
	public void setCodigoTramite(String codigoTramite) {
		this.codigoTramite = codigoTramite;
	}
	public String getNombreTramite() {
		return nombreTramite;
	}
	public void setNombreTramite(String nombreTramite) {
		this.nombreTramite = nombreTramite;
	}
	public String getDescTramite() {
		return descTramite;
	}
	public void setDescTramite(String descTramite) {
		this.descTramite = descTramite;
	}
	public String getCodSubtipologia() {
		return codSubtipologia;
	}
	public void setCodSubtipologia(String codSubtipologia) {
		this.codSubtipologia = codSubtipologia;
	}
	public String getTema() {
		return tema;
	}
	public void setTema(String tema) {
		this.tema = tema;
	}
	public String getFamilia() {
		return familia;
	}
	public void setFamilia(String familia) {
		this.familia = familia;
	}
	public String getSubfamilia() {
		return subfamilia;
	}
	public void setSubfamilia(String subfamilia) {
		this.subfamilia = subfamilia;
	}
	public String getArea() {
		return area;
	}
	public void setArea(String area) {
		this.area = area;
	}
	public String getAdministracionComponente() {
		return administracionComponente;
	}
	public void setAdministracionComponente(String administracionComponente) {
		this.administracionComponente = administracionComponente;
	}
	public String getNivelProteccion() {
		return nivelProteccion;
	}
	public void setNivelProteccion(String nivelProteccion) {
		this.nivelProteccion = nivelProteccion;
	}
	public String getClasificacionArchivo() {
		return clasificacionArchivo;
	}
	public void setClasificacionArchivo(String clasificacionArchivo) {
		this.clasificacionArchivo = clasificacionArchivo;
	}
	
	public String getEvalSeleccionEliminacion() {
		return evalSeleccionEliminacion;
	}
	public void setEvalSeleccionEliminacion(String evalSeleccionEliminacion) {
		this.evalSeleccionEliminacion = evalSeleccionEliminacion;
	}
	public String getCodEntidad() {
		return codEntidad;
	}
	public void setCodEntidad(String codEntidad) {
		this.codEntidad = codEntidad;
	}
	public String getCodUOrganizativaDestino() {
		return codUOrganizativaDestino;
	}
	public void setCodUOrganizativaDestino(String codUOrganizativaDestino) {
		this.codUOrganizativaDestino = codUOrganizativaDestino;
	}
	public Date getFechaBaja() {
		return fechaBaja;
	}
	public void setFechaBaja(Date fechaBaja) {
		this.fechaBaja = fechaBaja;
	}
	public Date getFechaRegistro() {
		return fechaRegistro;
	}
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}
	public void setSubtipologia(Subtipologia subtipologia) {
		this.subtipologia = subtipologia;
	}
	public Subtipologia getSubtipologia() {
		return subtipologia;
	}
	public void setTipologia(Tipologia tipologia) {
		this.tipologia = tipologia;
	}
	public Tipologia getTipologia() {
		return tipologia;
	}
	public void setPublicidad(String publicidad) {
		this.publicidad = publicidad;
	}
	public String getPublicidad() {
		return publicidad;
	}
	public void setEliminado(String eliminado) {
		this.eliminado = eliminado;
	}
	public String getEliminado() {
		return eliminado;
	}

	public void validar() {
		
		
		if(codSubtipologia==null || codSubtipologia.trim().equals("")){
			throw new IllegalArgumentException(COD_SUBTIPOLOGIA_NULL);
//			resultado.setConfirmacion(ConfirmacionTramite.SUBTIPOLOGIANULL);
//			resultado.setTramite(null);
		}
		else if(descTramite==null || descTramite.trim().equals("")){
			throw new IllegalArgumentException(DESC_TRAMITE_NULL);
		}
//		else if(tramite.getDescTramite()==null){
//			resultado.setConfirmacion(ConfirmacionTramite.DESCNULL);
//			resultado.setTramite(null);
//		}
//		else{
//			resultado.setConfirmacion(ConfirmacionTramite.CORRECTO);
//			resultado.setTramite(tramite);
//		}
//		
	}

}
