package es.alten.diputacion.add.modelo;

import java.util.Date;

import es.alten.diputacion.add.abstraccion.ObjetoDominio;

@SuppressWarnings("serial")
public class Usuario implements ObjetoDominio {
	public static final String NOM_NULL="es.alten.diputacion.add.modelo.Usuario.NOM_NULL";
	public static final String PASSWORD_NULL="es.alten.diputacion.add.modelo.Usuario.PASSWORD_NULL";
	public static final String ROL_NULL="es.alten.diputacion.add.modelo.Usuario.ROL_NULL";
	private String codigo;
	
	private String rol;
	
	private String nombre;

	private String password;
	
	private Date fechaAlta;
	
	private Date fechaBaja;
	
	private String eliminado;

	
	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public void setRol(String rol) {
		this.rol = rol;
	}

	public String getRol() {
		return rol;
	}
	
	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	
	public void setPassword(String password) {
		this.password = password;
	}

	public String getPassword() {
		return password;
	}

	public void setFechaAlta(Date fechaAlta) {
		this.fechaAlta = fechaAlta;
	}

	public Date getFechaAlta() {
		return fechaAlta;
	}
	
	public Date getFechaBaja() {
		return fechaBaja;
	}

	public void setFechaBaja(Date fechaBaja) {
		this.fechaBaja = fechaBaja;
	}

	public void setEliminado(String eliminado) {
		this.eliminado = eliminado;
	}

	public String getEliminado() {
		return eliminado;
	}

	public void validar() {
		
		
		if(nombre==null || nombre.trim().equals("")){
			throw new IllegalArgumentException(NOM_NULL);

		}
		else if(password==null || password.trim().equals("")){
			throw new IllegalArgumentException(PASSWORD_NULL);
		}
		else if(rol==null || rol.trim().equals("")){
			throw new IllegalArgumentException(ROL_NULL);
		}
	}
}